[![Continuous Integration](https://github.com/rjfarmer/gfort2py/actions/workflows/linux.yml/badge.svg)](https://github.com/rjfarmer/gfort2py/actions/workflows/linux.yml)
[![Coverage Status](https://coveralls.io/repos/github/rjfarmer/gfort2py/badge.svg?branch=main)](https://coveralls.io/github/rjfarmer/gfort2py?branch=main)
[![PyPI version](https://badge.fury.io/py/gfort2py.svg)](https://badge.fury.io/py/gfort2py)
[![DOI](https://zenodo.org/badge/72889348.svg)](https://zenodo.org/badge/latestdoi/72889348)
[![Python versions](https://img.shields.io/pypi/pyversions/gfort2py.svg)](https://img.shields.io/pypi/pyversions/gfort2py.svg)
[![gfortran versions](https://img.shields.io/badge/gfortran-8%7C9%7C10%7C11%7C12%7C13-blue)](https://img.shields.io/badge/gfortran-8%7C9%7C10%7C11%7C12%7C13-blue)
![PyPI - Downloads](https://img.shields.io/pypi/dm/gfort2py)


# gfort2py
Library to allow calling Fortran code from Python. Requires gfortran>=8.0, Works with python >= 3.7

## Build
Installing locally:
````bash
python -m pip install .
````

or install via pypi
````bash
python -m pip install --upgrade --user gfort2py
````

For a full list of supportetd platforms [see the support documentation](docs/support.md).

## Why use this over other Fortran to Python translators?

gfort2py has three main aims:

1. Make it trivially easy to call Fortran code from Python
2. Minimise the number of changes needed in the Fortran code to make this work.
3. Support as many Fortran features as possible.

We achieve this by tightly coupling the code to the gfortran compiler, by doing so we can easily embed assumptions about how advanced Fortran features work which makes development easier and minimises the number of changes needed on the Fortran side. 

gfort2py use the gfortran ``mod`` files to translate your Fortran code's ABI to Python-compatible types using Python's ctype library.
By using the ``mod`` file we can determine the call signature of all procedures, components of derived types, and the size and shapes of all module-level variables. As long as your code is inside a Fortran module, no other changes are needed to your Fortran code.

The downside to this approach is that we are tightly tied to gfortran's ABI, which means we can not support other non-gfortran compilers and we do not support all versions of gfortran. When gfortran next breaks its ABI (which happens rarely, the last break was gfortran 8) we will re-evaluate our supported gfortran versions.

## Using

There are two ways to load Fortran code into Python.
Either ``fFort`` or ``compile``. The recommended way
is via ``fFort`` for interfacing with existing code,
while ``compile`` is more suitable for wrapping short snippets of Fortran code

### fFort

Your Fortran code must be inside a module and then compiled as a shared library.

On linux: 
````bash
gfortran -fPIC -shared -c file.f90
gfortran -fPIC -shared -o libfile.so file.f90
````

On MacOS: 
````bash
gfortran -dynamiclib -c file.f90
gfortran -dynamiclib -o libfile.dylib file.f90
````

On Windows:
````bash
gfortran -shared -c file.f90
gfortran -shared -o libfile.dll file.f90
````

If the shared library needs other
shared libraries you may need to set the ``LD_LIBRARY_PATH`` environment variable, and it is also recommended to run chrpath on the shared 
libraries so you can access them from anywhere.

#### Python side
````python

import gfort2py as gf

SHARED_LIB_NAME=f'./test_mod.{gf.lib_ext()}' # Handle whether on Linux, Mac, or Windows
MOD_FILE_NAME='tester.mod'

x=gf.fFort(SHARED_LIB_NAME,MOD_FILE_NAME) 

````

> **_NOTE:_** The mod data is cached to speed up re-reading the data. To control this pass cache_folder to ``fFort``.
A value of False disables caching, a string sets the folder location, while leaving the argument as None defaults to platformdirs ``user_cache_dir``



### compile

````python

import gfort2py as gf


fstr = """
            integer function myfunc(x,y)
                integer :: x,y
                myfunc = x+y
            end function myfunc
"""

x  = gf.compile(string=fstr)

````

The Fortran code can also be in a file in which case:


````python

import gfort2py as gf

x  = gf.compile(file='my_fortran_file.f90')

````

In either casee the code will be compilied into a
Fortran module and then into a shared library. Any Fortran code is valid as long as it can be inserted into a Fortran Module (Its optional whether you need to wrap things in ``module``/``end module``, if you do not then that is done automatically for you).

Additional options available for ``compile``:

- FC: str Path to gfortran compilier
- FFLAGS: str Additional Fortran compile options. This defaults to -O2.
- LDLIBS: str Any additional libraries needed to be linked in (-l)
- LDFLAGS: str Locations of addtional libraries (-L)
- ouput: str Location to save intermediate files to. Defaults to ``None`` which saves files in a temporary location. Otherwise save to the location specified.

> **_NOTE:_** The interface to compile is currently considered unstable and may change.

### Interface


``x`` now contains all variables, parameters and procedures from the module (tab completable), and is independant on how the Fortran code was loaded.


### Functions
````python
y = x.func_name(a,b,c)
````

Will call the Fortran function with variables ``a,b,c`` and returns the result in ``y``.

``y`` will be  named tuple which contains (result, args). Where ``result`` is a python object for the return value (0 if a subroutine) and where args is a dict containing all arguments passed to the procedure (both those with intent (in) which will be unchanged and intent(inout/out) which may have changed).


### Variables

````python
x.some_var = 1
````

Sets a module variable to 1, will attempt to coerce it to the Fortran type

````python
x.some_var
````

Will return a Python object 


Optional arguments that are not present should be passed as a Python ``None``.


### Arrays

Arrays should be passed as a NumPy array of the correct size and shape.


Remember that Fortran by default has 1-based array numbering while Numpy
is 0-based.


If a procedure expects an unallocated array, then pass None as the argument, otherwise pass an array of the correct shape.

### Derived types

Derived types can be set with a dict 
````python
x.my_dt={'x':1,'y':'abc'}
````

````python
y=x.my_dt
y['x']
y['y']
````
If the derived type contains another derived type then you can set a dict in a dict

````python
x.my_dt={'x':1,'y':{'a':1}}
````

When setting the components of a derived type you do not need to specify
all of them at the same time.


If you have an array of derived types

````fortran
type(my_type), dimension(5) :: my_dt
type(my_type), dimension(5,5) :: my_dt2
````

Elements can be accessed via an index:

````python
x.my_dt[0]['x']
x.my_dt2[0,0]['x']
````

You can only access one component at a time (i.e no striding [:]). Allocatable derived types are not yet supported.

Derived types that are dummy arguments to a procedure are returned as a ``fDT`` type. This is a dict-like object where the components
can only be accessed via the item interface ``['x']`` and not as attributes ``.x``.  This was done so that we do not have a name collision
between Python functions (``keys``, ``items`` etc) and any Fortran-derived type components.

You can pass a ``fDT`` as an argument to a procedure.


### Quad precision variables

Quad precision (REAL128) variables are not natively supported by Python thus we need a different way to handle them. For now that is the [pyQuadp library](https://github.com/rjfarmer/pyQuadp) which can be installed from PyPi with:

````bash
python -m pip install pyquadp
````

or from a git checkout:

````bash
python -m pip install .[qaud]
````

For more details see pyQuadp's documentation, but briefly you can create a 
quad precision variable from an ``int``, ``float``, or ``string``. On return you will receive a ``qfloat`` type. This ``qfloat`` type acts like a Python Number, so you can do things like add, multiply, subtract etc this Number with other Numbers (including non-``qfloat`` types).

We currently only support scalar Quad's and scalar complex Quad's. Arrays of
quad precision values is planned but not yet supported. Quad values can also not be returned as a function result (this is a limitation in ``ctypes`` which we have no control over). Thus a quad precision value can only occur in:

- Module variables
- Parameters
- Procedure arguments

``pyQuadp`` is currently an optional requirement, you must manually install it, it does not get auto-installed when ``gfort2py`` is installed. If you try to access a quad precision variable without ``pyQuadp`` you should get a ``TypeError``.


### Callback arguments

To pass a Fortran function as a callback argument to another function then pass the function directly:

````python

y = x.callback_function(1)

y = x.another_function(x.callback_function)

````

Currently only Fortran functions can be passed. No checking is done to ensure that the callback function has the 
correct signature to be a callback to the second function.

The callback and also be created in Python at runtime (but must be valid Fortran):

````python

fstr = """
        integer function callback(x)
            integer :: x
            write(*,*) x
            callback = 3*x
        end function callback

        """

f = gf.compile(fstr)


y = x.another_function(f.callback)

````



## Testing

````bash
python -m pip install .[test]
pytest -v
````

To run unit tests

## Things that work

### Module variables

- [x] Scalars
- [x] Parameters
- [x] Characters
- [x] Explicit size arrays
- [X] Complex numbers (Scalar and parameters)
- [x] Getting a pointer
- [x] Getting the value of a pointer
- [x] Allocatable arrays
- [x] Derived types
- [x] Nested derived types
- [X] Explicit Arrays of derived types
- [ ] Allocatable Arrays of derived types
- [ ] Procedure pointers inside derived types
- [x] Derived types with dimension(:) array components (pointer, allocatable, target)
- [x] Allocatable strings (partial)
- [x] Explicit Arrays of strings
- [x] Allocatable arrays of strings
- [ ] Classes
- [ ] Abstract interfaces
- [ ] Common blocks
- [ ] Equivalences 
- [ ] Namelists
- [ ] Quad precision variables
- [ ] function overloading 

### Procedures

- [X] Basic calling (no arguments)
- [x] Argument passing (scalars)
- [x] Argument passing (strings)
- [X] Argument passing (explicit arrays)
- [x] Argument passing (assumed size arrays)
- [x] Argument passing (assumed shape arrays)
- [x] Argument passing (allocatable arrays)
- [x] Argument passing (derived types)
- [x] Argument intents (in, out, inout and none)
- [x] Passing characters of fixed size (len=10 or len=* etc)
- [x] Functions that return a character as their result
- [x] Allocatable strings (Only for things that do not get altered inside the procedure)
- [x] Explicit arrays of strings
- [x] Allocatable arrays of strings
- [x] Pointer arguments 
- [x] Optional arguments
- [x] Value arguments
- [x] Keyword arguments
- [ ] Generic/Elemental functions
- [ ] Functions as an argument
- [x] Unary operations (arguments that involve an expression to evaluate like dimension(n+1) or dimension((2*n)+1))
- [x] Functions returning an explicit array as their result 

### Common block elements

There is no way currently to access components of a common block.


## Accessing module file data

For those wanting to explore the module file format, there is a routine ``mod_info`` available from the top-level ``gfort2py`` module:

````python
module = gf.mod_info('file.mod')
````

That will parse the mod file and convert it into an intermediate format inside ``module``.

Variables or procedures can be looked up via the item interface (I also recommend using pprint for easier viewing):

````
from pprint import pprint

pprint(module['a_variable'])
````

Accessing the list of all available components can be had via ``module.keys()``.

You can also do:
````python
module = gf.mod_info('file.mod',json=True)
module['a_variable']
````

Then when you access each component the return value will be JSON-formatted. Note you can currently only access each component as JSON not the whole module file as JSON at the moment.


## Contributing

Bug reports are of course welcome and PR's should target the main branch.

For those wanting to get more involved, adding Fortran examples to the test suite of currently untested or unsupported features would be helpful. Bonus points if you also provide a Python test case (that can be marked ``@pytest.mark.skip`` if it does not work) that demonstrates the proposed interface to the new Fortran feature. Features with test cases will move higher in the order of things I add to the code.

See [how to write a test case](docs/test_suite.md) for details on how to write test cases.

For those wanting to go further and add the new feature themselves open a bug report and we can chat about what needs doing.

## Debugging

[Debugging instructions are here](docs/debugging.md)

# How many tests do we actually?

The main difficulty in writing gfort2py is handling ths head number of combinations of options that are available in Fortran code. 
If we consider a simple integer: How many different ways can we declare an integer?

First we must consider where the integer is declared:

- module variable
- dummy argument to a procedure
- return result of a function
- component of a derived type

Then we need to consider its storage:

- Is it a parameter?
- Optional?
- pass by value?
- pointer?
- kind?

Is it an array? If so:

- Explicit sized (dimension(5))
- Explicit but runtime sized (dimension(n) where n is another integer)
- Assumed size (dimension(*))
- Assumed shape (dimension(:))
- Allocatable

Then of course there are the combinations of the previous options. As well, for arrays its helpful to test multiple dimensions to ensure the
ordering is correct.

In an ideal world we would test every possible combination of valid options. But in reality we test as many as we can (and that we remember to test).


## Module variables

The simplest things to test are module variables. The basic structure of these tests is that python should set the value, a Fortran procedure should be
called to check the value is correct, then the Fortran procedure should alter the variable, and then python checks the final value again. This way
we check that python can read and set these values and that Fortran can interpret what python set.

A basic example:

Fortran side

````
integer :: a_int

logical function check_a_int()

    check_a_int = .false.

    if(a_int/=99) return

    a_int = 50
end function check_a_int
````


python side:

````
    def test_a_int(self):
        # Set value
        x.a_int = 99

        # Check python set it correctly
        assert x.a_int == 99

        # Call function to check variable was set
        res = x.check_a_int()

        # Check the result of the function call
        assert res.result
    
        # Check the variable again
        assert x.a_int == 50
````

Sometimes it is better to write to stdout than the explicitly check the value in Fortran.

````
integer :: a_int

subroutine check_a_int()

    write(*,*) a_int
    
end subroutine check_a_int
````

and

````
    # Note python tests must start with test_
    def test_a_int(self,capfd):
        # Set value
        x.a_int = 99

        # Check python set it correctly
        assert x.a_int == 99

        # This captures the stdout and stderr
        out, err = capfd.readouterr()

        # Call function to check variable was set
        res = x.check_a_int()

        assert int(strip(out)) == 99
````

## Procedure arguments

Similar to module variables but now instead of procedures without arguments there should be dummy arguments. It is not needed to test various intents
simply assume everything is intent(inout)

````
logical function check_args(x)
    integer :: x

    check_args = .false.

    if(x/=99) return

    x = 50
end function check_args
````

## Function result


````
integer function check_result(x)
    integer :: x

    check_args = -1

    if(x/=99) return

    check_result = 50
end function check_result
````


## Derived types

Same as above.


# Naming things

Generally names should be unique and describe what the thing is i.e if its an integer include ``int`` if its an array include the number of dimensions (``_3d``). Things that
test similar things should have similar names, i.e all thing testing explicit arrays of integers should be named the same except for the number of dimensions.


# Skipping tests

For things that don't work yet you can use the python decorator ``@pytest.mark.skip`` to skip the test. NOthing needs to be done on the Fortran side for tests that don't work yet.

# Bug reports

Bug reports make excellent test cases. If you can reduce the problem done to its minimal working example and add it to the test suite then there is a much better chance that the bug wont be re-introduced once it has been fixed. It also makes fixing things easier if there is a minimal working example.

! SPDX-License-Identifier: GPL-2.0+

module face

	use iso_fortran_env, only: output_unit, real128
	
	implicit none
	
	! Parameters
	integer, parameter :: dp = selected_real_kind(p=15)
	integer, parameter :: qp = selected_real_kind(p=30)
	integer, parameter :: lp = selected_int_kind(8)
	
	
	interface convert
		module procedure convert_int
		module procedure convert_real
		module procedure convert_real_dp
		module procedure convert_str
		module procedure convert_cmplx
	end interface convert
	

	interface operator(+)
		procedure :: my_add
	end interface 
	
	
	interface operator(-)
		procedure :: my_sub
	end interface 	
	
	
	interface assignment (=)
		procedure :: my_eq
	end interface 
	
	interface operator(.MYUN.)
		procedure :: my_unnary
	end interface 
	
	
	type my_type
		real :: a,b
	end type my_type
	
	
	contains
	
	
	real function my_add(a,b)
		type(my_type), intent(in) :: a
		integer, intent(in) :: b
		
		my_add = a%a*2 +b*2
	end function my_add
	
	real function my_sub(a,b)
		type(my_type), intent(in) :: a
		integer, intent(in) :: b
		
		my_sub = a%a*2 - b*2
	end function my_sub
	
	subroutine my_eq(a, b)
		type(my_type), intent(inout)  :: a
		integer,intent(in) :: b
		
		a%a = b*2
	end subroutine my_eq
	
	logical function my_unnary(a,b)
		type(my_type), intent(in) :: a,b
		
		my_unnary = a%a < b%a
	end function my_unnary


	elemental integer function func_elem_int(x)
		integer,intent(in) :: x

		func_elem_int = x*2

	end function func_elem_int
	
	elemental real function func_elem_real(x)
		real, intent(in) :: x

		func_elem_real = x*2

	end function func_elem_real

	elemental real(dp) function func_elem_real_dp(x)
		real(dp), intent(in) :: x

		func_elem_real_dp = x*2

	end function func_elem_real_dp


	subroutine test(x)
		integer :: x,i
		integer, allocatable,dimension(:) :: xarr,yarr
	
	
		write(*,*) func_elem_int(1)
		write(*,*) func_elem_int((/1,2,3,4,5/))
	
		allocate(xarr(x),yarr(x))
		
		do i=1,x
			xarr(i) = i**2
		end do
		
		yarr = func_elem_int(xarr)
	
	end subroutine test



	integer function convert_int(x)
		integer, intent(in) :: x
		convert_int = x * 5
	end function convert_int

	real function convert_real(x)
		real, intent(in) :: x
		convert_real = x * 5
	end function convert_real
	
	real(dp) function convert_real_dp(x)
		real(dp), intent(in) :: x
		convert_real_dp = x * 5
	end function convert_real_dp
	
	character(len=5) function convert_str(x)
		character(len=1), intent(in) :: x
		character(len=1) :: tmp
		integer :: i
		do i=0,5
			write(tmp,*) x
			convert_str(i:i) = tmp
		end do
	end function convert_str
	
	integer function convert_cmplx(x)
		complex, intent(in) :: x
		convert_cmplx = x * 5
	end function convert_cmplx

end module face

! SPDX-License-Identifier: GPL-2.0+

module oo

    use iso_fortran_env, only: output_unit, real128
    
    implicit none
    
    ! Parameters
    integer, parameter :: dp = selected_real_kind(p=15)
    integer, parameter :: qp = selected_real_kind(p=30)
    integer, parameter :: lp = selected_int_kind(8)
    
    
    TYPE s_proc
        integer :: a_int
        
        contains
        
        procedure, nopass :: proc_no_pass => func_dt_no_pass
        procedure, pass(this) :: proc_pass => sub_dt_pass
    
    end type s_proc
    
    
    type, extends(s_proc) :: s_proc_extend
        real(dp) :: a_real_dp
    
    end type s_proc_extend
    
    
    TYPE(s_proc) :: p_proc
    
    type(s_proc_extend) :: p_proc_extend
    
    contains
    
    integer function func_dt_no_pass(x)
        integer :: x
        
        func_dt_no_pass = 5*x
    
    end function func_dt_no_pass
    
    
    subroutine sub_dt_pass(this,x)
        class(s_proc), intent(inout) :: this
        integer :: x
        
        this%a_int = 5*x
        
    end subroutine sub_dt_pass
      


end module oo

! SPDX-License-Identifier: GPL-2.0+

module dt

    use iso_fortran_env, only: output_unit, real128
    
    implicit none
    
    ! Parameters
    integer, parameter :: dp = selected_real_kind(p=15)
    integer, parameter :: qp = selected_real_kind(p=30)
    integer, parameter :: lp = selected_int_kind(8)
    
    
    TYPE s_struct_basic
        integer           :: a_int
        integer(lp)       :: a_int_lp
        real              :: a_real
        real(dp)          :: a_real_dp
        character(len=10) :: a_str    
        integer, dimension(5) :: b_int_exp_1d 
        real(dp), dimension(5) :: b_real_dp_exp_1d 
        integer, allocatable, dimension(:) :: c_int_alloc_1d
        integer, pointer, dimension(:) :: d_int_point_1d => null()
    END TYPE s_struct_basic
    
    TYPE s_simple
        integer           :: x,y
    END TYPE s_simple
    
    
    TYPE s_struct_nested
        integer           :: a_int
        TYPE(s_struct_basic) :: f_struct
    END TYPE s_struct_nested
    
    TYPE s_struct_nested_2
        integer           :: a_int
        TYPE(s_struct_nested) :: f_nested
    END TYPE s_struct_nested_2
    
    TYPE(s_simple) :: f_struct_simple
    
    TYPE s_recursive
        integer           :: a_int
        TYPE(s_recursive),pointer :: s_recur
    end TYPE s_recursive
    
    TYPE s_recursive_2
        integer           :: a_int
        TYPE(s_recursive_1),pointer :: s_recur
    end TYPE s_recursive_2  
    
    TYPE s_recursive_1
        integer           :: a_int
        TYPE(s_recursive_2),pointer :: s_recur
    end TYPE s_recursive_1
    
    TYPE s_alloc_array
        integer           :: a_int
        real              :: a_real
        real(dp)          :: a_real_dp
        integer, dimension(0:15) :: bb
        character(len=20) :: a_str   
        integer,dimension(:,:,:),allocatable :: arr
        integer           :: a_int2
        real(dp), allocatable, dimension(:,:) :: alloc_arr
    END TYPE s_alloc_array
    
    
    TYPE(s_struct_basic) :: f_struct
    TYPE(s_struct_basic),dimension(2) :: f_struct_exp_1d
    TYPE(s_struct_basic),dimension(2,2) :: f_struct_exp_2d
    TYPE(s_struct_basic),dimension(:),  allocatable :: f_struct_alloc_1d
    TYPE(s_struct_basic),dimension(:,:),allocatable :: f_struct_alloc_2d
    TYPE(s_struct_basic),dimension(:),  pointer :: f_struct_point_1d => null()
    TYPE(s_struct_basic),dimension(:,:),pointer :: f_struct_point_2d => null()
    TYPE(s_struct_basic),dimension(2),  target :: f_struct_target_1d
    TYPE(s_struct_basic),dimension(2,2),target :: f_struct_target_2d
    
    
    TYPE(s_struct_nested) :: g_struct
    
    TYPE(s_struct_basic),dimension(2) :: g_struct_exp_1d
    TYPE(s_struct_basic),dimension(2,2) :: g_struct_exp_2d
    TYPE(s_struct_basic),dimension(:),  allocatable :: g_struct_alloc_1d
    TYPE(s_struct_basic),dimension(:,:),allocatable :: g_struct_alloc_2d
    TYPE(s_struct_basic),dimension(:),  pointer :: g_struct_point_1d => null()
    TYPE(s_struct_basic),dimension(:,:),pointer :: g_struct_point_2d => null()
    TYPE(s_struct_basic),dimension(2),  target :: g_struct_target_1d
    TYPE(s_struct_basic),dimension(2,2),target :: g_struct_target_2d
    
    
    TYPE(s_struct_nested_2) :: h_struct
    TYPE(s_struct_nested_2),dimension(2) :: h_struct_exp_1d
    TYPE(s_struct_nested_2),dimension(2,2) :: h_struct_exp_2d
    TYPE(s_struct_nested_2),dimension(:),  allocatable :: h_struct_alloc_1d
    TYPE(s_struct_nested_2),dimension(:,:),allocatable :: h_struct_alloc_2d
    TYPE(s_struct_nested_2),dimension(:),  pointer :: h_struct_point_1d => null()
    TYPE(s_struct_nested_2),dimension(:,:),pointer :: h_struct_point_2d => null()
    TYPE(s_struct_nested_2),dimension(2),  target :: h_struct_target_1d
    TYPE(s_struct_nested_2),dimension(2,2),target :: h_struct_target_2d
    
    
    TYPE(s_recursive) :: r_recur
    TYPE(s_recursive_1) :: r_recur_1
    TYPE(s_recursive_2) :: r_recur_2
    
    
    integer, target, dimension(5) :: e_int_target_1d
    
    !GH: #32
    type :: point 
        integer, dimension(4) :: iq
    end type point

    
    contains


 
    subroutine sub_f_simple_in(x)
        type(s_simple), intent(in) :: x
        
        write(output_unit,'(2(I2,1X))') x%x,x%y
    end subroutine sub_f_simple_in
    
    subroutine sub_f_simple_out(x)
        type(s_simple), intent(out) :: x
        
        x%x=1
        x%y=10
    end subroutine sub_f_simple_out
    
    subroutine sub_f_simple_inout(zzz)
        type(s_simple), intent(inout) :: zzz
        
        write(output_unit,'(2(I2,1X))') zzz%x,zzz%y
        zzz%x=1
        zzz%y=10
    end subroutine sub_f_simple_inout
    
    subroutine sub_f_simple_inoutp(zzz)
        type(s_simple),pointer, intent(inout) :: zzz
        
        write(output_unit,'(2(I2,1X))') zzz%x,zzz%y
        zzz%x=1
        zzz%y=10
    end subroutine sub_f_simple_inoutp
    
    
    logical function func_check_nested_dt() result(res10)
    
        if(g_struct%a_int==10 .and. &
            g_struct%f_struct%a_int==8) then
            res10=.True.
        else
            write(*,*) g_struct%a_int, g_struct%f_struct%a_int
            res10=.false.
        end if
    
    end function func_check_nested_dt      
    
    
    subroutine sub_f_struct_simple()
    
        write(*,*) f_struct_simple%x,f_struct_simple%y
        f_struct_simple%x =22
        f_struct_simple%y =55
    
    end subroutine sub_f_struct_simple
    
    
    subroutine sub_dt_alloc_ar(x)
        type(s_alloc_array) :: x
        
        allocate(x%alloc_arr(1:10,1:10))
        x%alloc_arr=99.d0
    
    end subroutine sub_dt_alloc_ar
    
    
    logical function func_set_f_struct()
        f_struct%a_int=5
        f_struct%a_int_lp=6_lp         
        f_struct%a_real = 7.0
        f_struct%a_real_dp=8.0_dp
        f_struct%a_str='9999999999'
        f_struct%b_int_exp_1d=(/9,10,11,12,13/)
        
        if (allocated(f_struct%c_int_alloc_1d)) deallocate(f_struct%c_int_alloc_1d)
        allocate(f_struct%c_int_alloc_1d(1:10))
        f_struct%c_int_alloc_1d=(/1,2,3,4,5,6,7,8,9,10/)
        
        e_int_target_1d = (/9,10,11,12,13/)
        nullify(f_struct%d_int_point_1d)
        f_struct%d_int_point_1d => e_int_target_1d
        
        func_set_f_struct = .true.
    
    end function func_set_f_struct
    
    logical function func_check_f_struct()
    
        write(*,*)         f_struct%a_int,loc(f_struct%a_int)
        write(*,*)         f_struct%a_int_lp  ,loc(f_struct%a_int_lp)      
        write(*,*)         f_struct%a_real,loc(f_struct%a_real)
        write(*,*)         f_struct%a_real_dp,loc(f_struct%a_real_dp)
        write(*,*)         f_struct%b_int_exp_1d,loc(f_struct%b_int_exp_1d)
        
        if (allocated(f_struct%c_int_alloc_1d))then
            write(*,*)      f_struct%c_int_alloc_1d,loc(f_struct%c_int_alloc_1d)
        end if
        
        if(associated(f_struct%d_int_point_1d))then
            write(*,*)      f_struct%d_int_point_1d,loc(f_struct%d_int_point_1d)
            write(*,*)      e_int_target_1d,loc(e_int_target_1d)
        end if        
    
    end function func_check_f_struct
    
    
    subroutine sub_s_struct_inout(s)
        type(s_struct_basic), intent(inout) :: s
        
        s% a_int = 99
        s% a_int_lp = 99_lp
        s% a_real = 99.0
        s% a_real_dp = 99.0_dp
        s% a_str ='1234567890'
        s% b_int_exp_1d = (/1,2,3,4,5/)
        s% b_real_dp_exp_1d = (/1.0,2.0,3.0,4.0,5.0/)
        if (.not. allocated(s% c_int_alloc_1d)) allocate(s% c_int_alloc_1d(1:10))
        s% c_int_alloc_1d = 99
    
    end subroutine sub_s_struct_inout
    
    
    subroutine sub_struct_exp_1d(x)
        TYPE(s_struct_basic),dimension(2) :: x
        
        x(1)%a_int = 5
        x(2)%a_int = 9
        
        x(1)%b_int_exp_1d = 66
        x(2)%b_int_exp_1d = 77
        
    end subroutine sub_struct_exp_1d
    

    logical function check_g_struct_exp_2d()
        
        check_g_struct_exp_2d = .false.
        if(g_struct_exp_2d(1,1)%a_int == 1 .and. &
            g_struct_exp_2d(2,1)%a_int == 2 .and. &
            g_struct_exp_2d(1,2)%a_int == 3 .and. &
            g_struct_exp_2d(2,2)%a_int == 4 ) then
            check_g_struct_exp_2d = .true.
        else
            write(*,*) g_struct_exp_2d(1,1)%a_int, g_struct_exp_2d(2,1)%a_int,g_struct_exp_2d(1,2)%a_int,g_struct_exp_2d(2,2)%a_int 
        end if
    
    
    end function check_g_struct_exp_2d


    logical function check_recur()

        check_recur = .false.
        
        if(r_recur%a_int==9 .and. &
            r_recur%s_recur%a_int==9 .and. &
            r_recur%s_recur%s_recur%a_int == 9) then
            check_recur = .true.
        else
            write(*,*) r_recur%a_int
            if(associated(r_recur%s_recur)) write(*,*) r_recur%s_recur%a_int
            if(associated(r_recur%s_recur%s_recur)) write(*,*) r_recur%s_recur%s_recur%a_int
        end if


    end function check_recur


    function func_return_s_struct_nested_2() result(s)
        type(s_struct_nested_2)::s
        s%a_int = 123
        s%f_nested%a_int = 234
        s%f_nested%f_struct%a_int = 345
    end function func_return_s_struct_nested_2


    subroutine derived_structure(p)
        ! GH: #32
        type(point), intent(out) :: p
        p = point([10,20,30,40])
        write(*,'(4(I2,1X))') p
    end subroutine derived_structure


end module dt

! SPDX-License-Identifier: GPL-2.0+

module ptrs

	use iso_fortran_env, only: output_unit, real128
	
	implicit none
	
	! Parameters
	integer, parameter :: dp = selected_real_kind(p=15)
	integer, parameter :: qp = selected_real_kind(p=30)
	integer, parameter :: lp = selected_int_kind(8)
	
	integer,pointer            :: a_int_point => null()
	integer(lp),pointer        :: a_int_lp_point => null()
	real,pointer               :: a_real_point => null()
	real(dp),pointer           :: a_real_dp_point => null()
	real(qp),pointer           :: a_real_qp_point => null()
	character(len=10),pointer  :: a_str_point => null()
	
	integer,target            :: a_int_target
	integer(lp),target        :: a_int_lp_target
	real,target               :: a_real_target
	real(dp),target           :: a_real_dp_target
	real(qp),target           :: a_real_qp_target
	character(len=10),target  :: a_str_target
	
	integer, pointer, dimension(:) :: d_int_point_1d => null()
	integer, pointer, dimension(:,:) :: d_int_point_2d => null()
	integer, pointer, dimension(:,:,:) :: d_int_point_3d => null()
	integer, pointer, dimension(:,:,:,:) :: d_int_point_4d => null()
	integer, pointer, dimension(:,:,:,:,:) :: d_int_point_5d => null()
	
	real, pointer, dimension(:) :: d_real_point_1d => null()
	real, pointer, dimension(:,:) :: d_real_point_2d => null()
	real, pointer, dimension(:,:,:) :: d_real_point_3d => null()
	real, pointer, dimension(:,:,:,:) :: d_real_point_4d => null()
	real, pointer, dimension(:,:,:,:,:) :: d_real_point_5d => null()
	
	real(dp), pointer, dimension(:) :: d_real_dp_point_1d => null()
	real(dp), pointer, dimension(:,:) :: d_real_dp_point_2d => null()
	real(dp), pointer, dimension(:,:,:) :: d_real_dp_point_3d => null()
	real(dp), pointer, dimension(:,:,:,:) :: d_real_dp_point_4d => null()
	real(dp), pointer, dimension(:,:,:,:,:) :: d_real_dp_point_5d => null()
	
	integer, target, dimension(5) :: e_int_target_1d
	integer, target, dimension(5,5) :: e_int_target_2d
	integer, target, dimension(5,5,5) :: e_int_target_3d
	integer, target, dimension(5,5,5,5) :: e_int_target_4d
	integer, target, dimension(5,5,5,5,5) :: e_int_target_5d
	
	real, target, dimension(5) :: e_real_target_1d
	real, target, dimension(5,5) :: e_real_target_2d
	real, target, dimension(5,5,5) :: e_real_target_3d
	real, target, dimension(5,5,5,5) :: e_real_target_4d
	real, target, dimension(5,5,5,5,5) :: e_real_target_5d
	
	real(dp), target, dimension(5) :: e_real_dp_target_1d
	real(dp), target, dimension(5,5) :: e_real_dp_target_2d
	real(dp), target, dimension(5,5,5) :: e_real_dp_target_3d
	real(dp), target, dimension(5,5,5,5) :: e_real_dp_target_4d
	real(dp), target, dimension(5,5,5,5,5) :: e_real_dp_target_5d
	
	
	contains
	
	subroutine sub_set_ptrs()
	
		if(associated(d_int_point_1d)) write(*,*) d_int_point_1d
		d_int_point_1d => e_int_target_1d
		
		d_int_point_1d = 9
	
	end subroutine sub_set_ptrs



end module ptrs

! SPDX-License-Identifier: GPL-2.0+

module explicit_arrays

	use iso_fortran_env, only: output_unit, real128
	
	implicit none
	
	! Parameters
	integer, parameter :: dp = selected_real_kind(p=15)
	integer, parameter :: qp = selected_real_kind(p=30)
	integer, parameter :: lp = selected_int_kind(8)
	
	
	integer,parameter,dimension(10) :: const_int_arr=(/1,2,3,4,5,6,7,8,9,0/)
	real,parameter,dimension(10) :: const_real_arr=(/1.0,2.0,3.0,4.0,5.0,6.0,7.0,8.0,9.0,0.0/)
	real(dp),parameter,dimension(10) :: const_real_dp_arr=(/1_dp,2_dp,3_dp,4_dp,5_dp,6_dp,7_dp,8_dp,9_dp,0_dp/)
	logical, parameter, dimension(5) :: const_logical_arr=(/.true.,.false.,.true.,.false.,.true./)

	! Arrays
	integer, dimension(5) :: b_int_exp_1d
	integer, dimension(5,5) :: b_int_exp_2d
	integer, dimension(5,5,5) :: b_int_exp_3d
	integer, dimension(5,5,5,5) :: b_int_exp_4d
	integer, dimension(5,5,5,5,5) :: b_int_exp_5d
	
	real, dimension(5) :: b_real_exp_1d
	real, dimension(5,5) :: b_real_exp_2d
	real, dimension(5,5,5) :: b_real_exp_3d
	real, dimension(5,5,5,5) :: b_real_exp_4d
	real, dimension(5,5,5,5,5) :: b_real_exp_5d
	
	real(dp), dimension(5) :: b_real_dp_exp_1d
	real(dp), dimension(5,5) :: b_real_dp_exp_2d
	real(dp), dimension(5,5,5) :: b_real_dp_exp_3d
	real(dp), dimension(5,5,5,5) :: b_real_dp_exp_4d
	real(dp), dimension(5,5,5,5,5) :: b_real_dp_exp_5d
	real(dp), dimension(2,3,4,5,6) :: b_real_exp_5d_2


	character(len=10), dimension(5) :: b_str_exp_1d
	character(len=10), dimension(5,5) :: b_str_exp_2d
	character(len=10), dimension(5,5,5) :: b_str_exp_3d
	character(len=10), dimension(5,5,5,5) :: b_str_exp_4d
	character(len=10), dimension(5,5,5,5,5) :: b_str_exp_5d     


	integer, dimension(5) :: b_int_exp_1d_set = (/1,2,3,4,5/)
	
	
	contains


	subroutine sub_array_n_int_1d(n,x)
		integer,intent(in) :: n
		integer,dimension(n), intent(in) :: x
		
		write(output_unit,'(5(I1,1X))') x
	end subroutine sub_array_n_int_1d
	
	subroutine sub_array_n_int_2d(n,m,x)
		integer,intent(in) :: n, m
		integer,dimension(n,m), intent(in) :: x
		
		write(output_unit,'(25(I1,1X))') x
	end subroutine sub_array_n_int_2d
	
	subroutine sub_exp_array_int_1d(x)
		integer,dimension(5), intent(in) :: x
		
		write(output_unit,'(5(I1,1X))') x
	end subroutine sub_exp_array_int_1d
	
	subroutine sub_exp_array_int_2d(x)
		integer,dimension(5,5), intent(in) :: x
		integer :: i,j,k
		write(output_unit,'(25(I2.2,1X))') x
	end subroutine sub_exp_array_int_2d
	
	subroutine sub_exp_array_int_3d(x)
		integer,dimension(5,5,5), intent(in) :: x
		write(output_unit,'(125(I3.3,1X))') x
	end subroutine sub_exp_array_int_3d
	
	subroutine sub_exp_array_real_1d(x)
		real,dimension(5), intent(in) :: x
		write(output_unit,'(5(F5.1,1X))') x
	end subroutine sub_exp_array_real_1d
	
	subroutine sub_exp_array_real_2d(x)
		real,dimension(5,5), intent(in) :: x
		write(output_unit,'(25(F5.1,1X))') x
	end subroutine sub_exp_array_real_2d  
	
	subroutine sub_exp_array_real_3d(x)
		real,dimension(5,5,5), intent(in) :: x
		write(output_unit,'(125(F5.1,1X))') x
	end subroutine sub_exp_array_real_3d
	
	subroutine sub_exp_array_real_dp_1d(x)
		real(dp),dimension(5), intent(in) :: x
		write(output_unit,'(5(F5.1,1X))') x
	end subroutine sub_exp_array_real_dp_1d
	
	subroutine sub_exp_array_real_dp_2d(x)
		real(dp),dimension(5,5), intent(in) :: x
		write(output_unit,'(25(F5.1,1X))') x
	end subroutine sub_exp_array_real_dp_2d  
	
	subroutine sub_exp_array_real_dp_3d(x)
		real(dp),dimension(5,5,5), intent(in) :: x
		write(output_unit,'(125(F5.1,1X))') x
	end subroutine sub_exp_array_real_dp_3d
	
	subroutine sub_exp_array_int_1d_multi(y,x,z)
		integer,dimension(5), intent(in) :: x
		integer,intent(in) :: y,z
		
		write(output_unit,'(I2,1X,5(I1,1X),I2,1X)') y,x,z
	end subroutine sub_exp_array_int_1d_multi

	subroutine sub_exp_inout(x)
	 integer,dimension(5),intent(inout) :: x
	 x=2*x
	end subroutine sub_exp_inout   
      
	logical function func_logical_multi(a,b,x,c,d) result(res2)
		real(dp),intent(in) :: a,b,c,d
		logical, dimension(5), intent(in) :: x
		res2 =.false.
		if(all(x.eqv..true.)) res2 = .true.
	end function func_logical_multi
	
	
	function func_mesh_exp(N) result(mesh)
		! Github issues #13
		integer, intent(in) :: N
		integer(dp) :: mesh(N+1)
		integer :: i
		
		do i=1,n+1
			mesh(i) = i
		end do
		
	end function func_mesh_exp


	subroutine func_mesh_exp2(x,N) 
		integer, intent(in) :: N
		integer :: x(N+1)
		integer :: i
		
		do i=1,n+1
			x(i) = i
		end do
		
	end subroutine func_mesh_exp2


	subroutine func_mesh_exp3(x,N) 
		integer, intent(in) :: N
		integer :: x((N*2)+1)
		integer :: i
		
		do i=1,(N*2)+1
			x(i) = i
		end do
		
	end subroutine func_mesh_exp3
	
	
	subroutine check_exp_2d_2m3(arr, success)
		! Github issues #19
		integer, dimension(2,3) :: arr
		logical :: success
		
		success=.false.
		
		if(arr(1,2)==1 .and. arr(2,1)==2 .and. arr(2,3) == 3 &
		.and. arr(1,1)==0 .and. arr(2,2)==0 .and. arr(1,3) ==0) success = .true.
		

	end subroutine check_exp_2d_2m3
	
	
	subroutine check_exp_2d_2m3_nt(arr, NT, success)
		! Github issues #19
		integer, intent(in) :: NT
		integer, dimension(3,NT) :: arr
		logical :: success
		integer :: i
		
		success=.false.
		
		if(arr(1,2)==1 .and. arr(2,1)==2 .and. arr(2,3) == 3 .and. arr(2,4) ==4 ) success = .true.
		
!		do i=1,3
!			write(*,*) arr(i,:)
!		end do
		
		arr(1,NT) = 5

	end subroutine check_exp_2d_2m3_nt	
	
	

end module explicit_arrays

! SPDX-License-Identifier: GPL-2.0+

module basic2
	implicit none
	integer, parameter :: lp2 = selected_int_kind(8)

	integer :: test2_x


end module basic2



module basic
	use iso_fortran_env, only: output_unit, real128
	use basic2

	implicit none
	
	     ! Parameters
		integer, parameter :: dp = selected_real_kind(p=15)
		integer, parameter :: qp = selected_real_kind(p=30)
		integer, parameter :: lp = selected_int_kind(8)
		
		integer, parameter      :: const_int=1
		integer, parameter      :: const_int_p1=const_int+1
		integer(lp), parameter  :: const_int_lp=1_lp

		logical,parameter :: const_logical_true=.true.
		logical,parameter :: const_logical_false=.false.

		
		real, parameter     :: const_real=1.0
		real(dp), parameter :: const_real_dp=1.0_dp
		real(dp), parameter :: const_real_pi_dp=3.14_dp
		real(qp), parameter :: const_real_qp=1.0_qp

		integer, parameter :: const_neg_int = -1.0
		real(dp),parameter :: const_neg_real = -3.14_dp
			
		! Variables
		integer           :: a_int
		integer(lp)       :: a_int_lp
		real              :: a_real
		real(dp)          :: a_real_dp
		real(qp)          :: a_real_qp
		
		! Set variables
		integer           :: a_int_set=5
		integer(lp)       :: a_int_lp_set=6
		real              :: a_real_set=7.0
		real(dp)          :: a_real_dp_set=8.0_dp
		real(qp)          :: a_real_qp_set=9.0_qp

		
	contains


		subroutine sub_no_args()
			write(output_unit,*) "1"
		end subroutine sub_no_args
		
		integer function func_int_no_args()
			func_int_no_args=2
			! write(output_unit,*) 2
		end function func_int_no_args
		
		real function func_real_no_args()
			func_real_no_args=3.0
			! write(output_unit,*) 3.0
		end function func_real_no_args
		
		real(dp) function func_real_dp_no_args()
			func_real_dp_no_args=4.0_dp
			! write(output_unit,*) 4.0_dp
		end function func_real_dp_no_args
		
		subroutine sub_int_in(x)
			integer, intent(in) ::x
			write(output_unit,*) 2*x
		end subroutine sub_int_in
		
		subroutine sub_int_out(x)
			integer, intent(out) :: x
			x=1
		end subroutine sub_int_out
		
		subroutine sub_int_inout(x)
			integer, intent(inout) :: x
			x=2*x
		end subroutine sub_int_inout    
		
		subroutine sub_real_inout(x)
			real, intent(inout) :: x
			x=2*x
		end subroutine sub_real_inout   
		
		subroutine sub_multi_inout(x,y,z)
			integer, intent(in) :: x
			integer, intent(inout) :: y
			integer, intent(out) :: z
			y=y*x
			z=y*x
		end subroutine sub_multi_inout  
		
		subroutine sub_int_no_intent(x)
			integer :: x
			x=2*x
		end subroutine sub_int_no_intent 
		
		integer function func_int_in(x)
			integer, intent(in) :: x
			func_int_in=2*x
		end function func_int_in
		
		integer function func_int_in_multi(x,y,z)
			integer, intent(in) ::x,y,z
			func_int_in_multi=x+y+z
		end function func_int_in_multi
		
		subroutine sub_alter_mod()
			a_int=99
			a_int_lp=99_lp
			a_real=99.0
			a_real_dp=99.0_dp
			a_real_qp=99.0_qp
		end subroutine sub_alter_mod
      
		logical function func_check_mod()
			func_check_mod = .false.
		
			if( a_int==5 .and. &
				a_int_lp==5_lp .and. &
				a_real==5.0 .and. &
			    a_real_dp==5.0_dp .and. &
			    a_real_qp==5.0_qp) then
			    
			    func_check_mod = .true.
			end if
		end function func_check_mod
      
      
		integer function func_intent_out(y,x)
			integer, intent(in) :: y
			integer, intent(out) :: x
		
			func_intent_out = y
			x =y
		
		end function func_intent_out
		
		function func_result(y,x) result(z)
			integer, intent(in) :: y
			integer, intent(out) :: x
			integer :: z
		
			z = y*2
			x =y
		
		end function func_result
		
		
		function func_int_value(x) result(z)
			integer, intent(in),value :: x
			integer :: z
		
			z = x*2
		
		end function func_int_value

		subroutine sub_int_opt(x)
			integer, optional, intent(in) :: x
		
			if(present(x)) then
				write(*,*) 100
			else
				write(*,*) 200
			end if  
		end subroutine sub_int_opt
    

		subroutine sub_int_opt_val(x)
			integer, optional, intent(in),value :: x
		
			if(present(x)) then
				write(*,*) 100
			else
				write(*,*) 200
			end if  
		end subroutine sub_int_opt_val
      
		logical function func_return_res(x) result(res1)
			integer, intent(in) :: x
			res1 =.false.
			if(x==2) res1 = .true.
		end function func_return_res
		

		subroutine sub_int_p(zzz)
			integer,pointer, intent(inout) :: zzz
			
			write(output_unit,'(I2)') zzz
			
			zzz = 5
		end subroutine sub_int_p
		
		subroutine sub_real_p(zzz)
			real,pointer, intent(inout) :: zzz
			
			write(output_unit,'(F5.2)') zzz
			
			zzz = 5.0
		end subroutine sub_real_p
		
		subroutine sub_many_args(a,b,c,d,e,f,g,h,i,j,k,l)
			real :: a,b,c,d
			logical :: e,f,g
			character(len=*) :: h,i,j,k,l
			
			!write(*,*) a,b,c,d,e,f,g,h,i,j,k,l
		end subroutine sub_many_args
		
		
		subroutine sub_use_mod()
		
			test2_x = 1
		
		end subroutine sub_use_mod
   

		logical function func_test_bool(x)
			integer,intent(in) :: x

			if(x==0) then
				func_test_bool = .false.
			else
				func_test_bool = .true.
			end if

		end function func_test_bool

end module basic

module test2
	implicit none
      integer, parameter :: lp2 = selected_int_kind(8)

   INTEGER :: test2_x

   TYPE s_simple2
      integer           :: x,y,z
   END TYPE s_simple2
   
   TYPE s_struct_AA
      integer           :: a_int
      real              :: a_real
      double precision          :: a_real_dp
      character(len=1_lp2) :: a_str   
      integer,dimension(:,:,:),allocatable :: arr
      integer           :: a_int2
   END TYPE s_struct_AA

end module test2

module tester
   use iso_fortran_env, only: output_unit
   use test2


	implicit none
      
      ! Parameters
      integer, parameter :: dp = selected_real_kind(p=15)
      integer, parameter :: qp = selected_real_kind(p=31)
      integer, parameter :: lp = selected_int_kind(8)
      
      integer, parameter      :: const_int=1
      integer, parameter      :: const_int_p1=const_int+1
      integer(lp), parameter  :: const_int_lp=1_lp
      
      real, parameter     :: const_real=1.0
      real(dp), parameter :: const_real_dp=1.0_dp
      real(dp), parameter :: const_real_pi_dp=3.14_dp
      real(qp), parameter :: const_real_qp=1.0_qp
      complex, parameter  :: const_cmplx=(1.0,1.0)
      complex(dp), parameter  :: const_cmplx_dp=(1.0_dp,1.0_dp)
      complex(qp), parameter  :: const_cmplx_qp=(1.0_qp,1.0_qp)
      
      character(len=10),parameter :: const_str='1234567890'
      
      integer,parameter,dimension(10) :: const_int_arr=(/1,2,3,4,5,6,7,8,9,0/)
      real,parameter,dimension(10) :: const_real_arr=(/1.0,2.0,3.0,4.0,5.0,6.0,7.0,8.0,9.0,0.0/)
      real(dp),parameter,dimension(10) :: const_real_dp_arr=(/1_dp,2_dp,3_dp,4_dp,5_dp,6_dp,7_dp,8_dp,9_dp,0_dp/)


      ! Variables
      integer           :: a_int
      integer(lp)       :: a_int_lp
      real              :: a_real
      real(dp)          :: a_real_dp
      real(qp)          :: a_real_qp
      character(len=10) :: a_str
      complex           :: a_cmplx
      complex(dp)       :: a_cmplx_dp
      complex(qp)       :: a_cmplx_qp
      
      integer,pointer            :: a_int_point => null()
      integer(lp),pointer        :: a_int_lp_point => null()
      real,pointer               :: a_real_point => null()
      real(dp),pointer           :: a_real_dp_point => null()
      real(qp),pointer           :: a_real_qp_point => null()
      character(len=10),pointer  :: a_str_point => null()
      
      integer,target            :: a_int_target
      integer(lp),target        :: a_int_lp_target
      real,target               :: a_real_target
      real(dp),target           :: a_real_dp_target
      real(qp),target           :: a_real_qp_target
      character(len=10),target  :: a_str_target
      
      
      ! Arrays
      integer, dimension(5) :: b_int_exp_1d
      integer, dimension(5,5) :: b_int_exp_2d
      integer, dimension(5,5,5) :: b_int_exp_3d
      integer, dimension(5,5,5,5) :: b_int_exp_4d
      integer, dimension(5,5,5,5,5) :: b_int_exp_5d
      
      real, dimension(5) :: b_real_exp_1d
      real, dimension(5,5) :: b_real_exp_2d
      real, dimension(5,5,5) :: b_real_exp_3d
      real, dimension(5,5,5,5) :: b_real_exp_4d
      real, dimension(5,5,5,5,5) :: b_real_exp_5d
      
      real(dp), dimension(5) :: b_real_dp_exp_1d
      real(dp), dimension(5,5) :: b_real_dp_exp_2d
      real(dp), dimension(5,5,5) :: b_real_dp_exp_3d
      real(dp), dimension(5,5,5,5) :: b_real_dp_exp_4d
      real(dp), dimension(5,5,5,5,5) :: b_real_dp_exp_5d
      
      
      integer, allocatable, dimension(:) :: c_int_alloc_1d
      integer, allocatable, dimension(:,:) :: c_int_alloc_2d
      integer, allocatable, dimension(:,:,:) :: c_int_alloc_3d
      integer, allocatable, dimension(:,:,:,:) :: c_int_alloc_4d
      integer, allocatable, dimension(:,:,:,:,:) :: c_int_alloc_5d
      
      real, allocatable, dimension(:) :: c_real_alloc_1d
      real, allocatable, dimension(:,:) :: c_real_alloc_2d
      real, allocatable, dimension(:,:,:) :: c_real_alloc_3d
      real, allocatable, dimension(:,:,:,:) :: c_real_alloc_4d
      real, allocatable, dimension(:,:,:,:,:) :: c_real_alloc_5d
      
      real(dp), allocatable, dimension(:) :: c_real_dp_alloc_1d
      real(dp), allocatable, dimension(:,:) :: c_real_dp_alloc_2d
      real(dp), allocatable, dimension(:,:,:) :: c_real_dp_alloc_3d
      real(dp), allocatable, dimension(:,:,:,:) :: c_real_dp_alloc_4d
      real(dp), allocatable, dimension(:,:,:,:,:) :: c_real_dp_alloc_5d
      

      integer, pointer, dimension(:) :: d_int_point_1d => null()
      integer, pointer, dimension(:,:) :: d_int_point_2d => null()
      integer, pointer, dimension(:,:,:) :: d_int_point_3d => null()
      integer, pointer, dimension(:,:,:,:) :: d_int_point_4d => null()
      integer, pointer, dimension(:,:,:,:,:) :: d_int_point_5d => null()
      
      real, pointer, dimension(:) :: d_real_point_1d => null()
      real, pointer, dimension(:,:) :: d_real_point_2d => null()
      real, pointer, dimension(:,:,:) :: d_real_point_3d => null()
      real, pointer, dimension(:,:,:,:) :: d_real_point_4d => null()
      real, pointer, dimension(:,:,:,:,:) :: d_real_point_5d => null()
      
      real(dp), pointer, dimension(:) :: d_real_dp_point_1d => null()
      real(dp), pointer, dimension(:,:) :: d_real_dp_point_2d => null()
      real(dp), pointer, dimension(:,:,:) :: d_real_dp_point_3d => null()
      real(dp), pointer, dimension(:,:,:,:) :: d_real_dp_point_4d => null()
      real(dp), pointer, dimension(:,:,:,:,:) :: d_real_dp_point_5d => null()
      
      integer, target, dimension(5) :: e_int_target_1d
      integer, target, dimension(5,5) :: e_int_target_2d
      integer, target, dimension(5,5,5) :: e_int_target_3d
      integer, target, dimension(5,5,5,5) :: e_int_target_4d
      integer, target, dimension(5,5,5,5,5) :: e_int_target_5d
      
      real, target, dimension(5) :: e_real_target_1d
      real, target, dimension(5,5) :: e_real_target_2d
      real, target, dimension(5,5,5) :: e_real_target_3d
      real, target, dimension(5,5,5,5) :: e_real_target_4d
      real, target, dimension(5,5,5,5,5) :: e_real_target_5d
      
      real(dp), target, dimension(5) :: e_real_dp_target_1d
      real(dp), target, dimension(5,5) :: e_real_dp_target_2d
      real(dp), target, dimension(5,5,5) :: e_real_dp_target_3d
      real(dp), target, dimension(5,5,5,5) :: e_real_dp_target_4d
      real(dp), target, dimension(5,5,5,5,5) :: e_real_dp_target_5d
      
      
      TYPE s_struct_basic
         integer           :: a_int
         integer(lp)       :: a_int_lp
         real              :: a_real
         real(dp)          :: a_real_dp
         character(len=10) :: a_str    
         integer, dimension(5) :: b_int_exp_1d 
         integer, allocatable, dimension(:) :: c_int_alloc_1d
         integer, pointer, dimension(:) :: d_int_point_1d => null()
      END TYPE s_struct_basic
      
      TYPE s_simple
         integer           :: x,y
      END TYPE s_simple
      
      
      TYPE s_struct_nested
         integer           :: a_int
         TYPE(s_struct_basic) :: f_struct
      END TYPE s_struct_nested
      
      TYPE s_struct_nested_2
         integer           :: a_int
         TYPE(s_struct_nested) :: f_nested
      END TYPE s_struct_nested_2
      
      TYPE(s_simple) :: f_struct_simple
      
      ! From second module
      TYPE(s_simple2) :: f_struct_simple2
      
      TYPE s_recursive
         integer           :: a_int
         TYPE(s_recursive),pointer :: s_recur
      end TYPE s_recursive
      
      TYPE s_recursive_2
         integer           :: a_int
         TYPE(s_recursive_1),pointer :: s_recur
      end TYPE s_recursive_2  
      
      TYPE s_recursive_1
         integer           :: a_int
         TYPE(s_recursive_2),pointer :: s_recur
      end TYPE s_recursive_1
      
      TYPE(s_struct_basic) :: f_struct
      TYPE(s_struct_basic),dimension(2) :: f_struct_exp_2d
      TYPE(s_struct_basic),dimension(2,2) :: f_struct_exp_1d
      TYPE(s_struct_basic),dimension(:),  allocatable :: f_struct_alloc_1d
      TYPE(s_struct_basic),dimension(:,:),allocatable :: f_struct_alloc_2d
      TYPE(s_struct_basic),dimension(:),  pointer :: f_struct_point_1d => null()
      TYPE(s_struct_basic),dimension(:,:),pointer :: f_struct_point_2d => null()
      TYPE(s_struct_basic),dimension(2),  target :: f_struct_target_1d
      TYPE(s_struct_basic),dimension(2,2),target :: f_struct_target_2d


      TYPE(s_struct_nested) :: g_struct
      TYPE(s_struct_nested),dimension(2) :: g_struct_exp_2d
      TYPE(s_struct_nested),dimension(2,2) :: g_struct_exp_1d
      TYPE(s_struct_nested),dimension(:),  allocatable :: g_struct_alloc_1d
      TYPE(s_struct_nested),dimension(:,:),allocatable :: g_struct_alloc_2d
      TYPE(s_struct_nested),dimension(:),  pointer :: g_struct_point_1d => null()
      TYPE(s_struct_nested),dimension(:,:),pointer :: g_struct_point_2d => null()
      TYPE(s_struct_nested),dimension(2),  target :: g_struct_target_1d
      TYPE(s_struct_nested),dimension(2,2),target :: g_struct_target_2d
      
      
      TYPE(s_struct_nested_2) :: h_struct
      TYPE(s_struct_nested_2),dimension(2) :: h_struct_exp_2d
      TYPE(s_struct_nested_2),dimension(2,2) :: h_struct_exp_1d
      TYPE(s_struct_nested_2),dimension(:),  allocatable :: h_struct_alloc_1d
      TYPE(s_struct_nested_2),dimension(:,:),allocatable :: h_struct_alloc_2d
      TYPE(s_struct_nested_2),dimension(:),  pointer :: h_struct_point_1d => null()
      TYPE(s_struct_nested_2),dimension(:,:),pointer :: h_struct_point_2d => null()
      TYPE(s_struct_nested_2),dimension(2),  target :: h_struct_target_1d
      TYPE(s_struct_nested_2),dimension(2,2),target :: h_struct_target_2d


      TYPE(s_recursive) :: r_recur
      TYPE(s_recursive_1) :: r_recur_1
      TYPE(s_recursive_2) :: r_recur_2

      contains
      
      
      subroutine sub_no_args()
         write(output_unit,*) "1"
      end subroutine sub_no_args
      
      integer function func_int_no_args()
         func_int_no_args=2
        ! write(output_unit,*) 2
      end function func_int_no_args
      
      real function func_real_no_args()
         func_real_no_args=3.0
        ! write(output_unit,*) 3.0
      end function func_real_no_args
      
      real(dp) function func_real_dp_no_args()
         func_real_dp_no_args=4.0_dp
        ! write(output_unit,*) 4.0_dp
      end function func_real_dp_no_args
      
      subroutine sub_int_in(x)
         integer, intent(in) ::x
         write(output_unit,*) 2*x
      end subroutine sub_int_in
      
      subroutine sub_int_out(x)
         integer, intent(out) :: x
         x=1
      end subroutine sub_int_out
      
      subroutine sub_int_inout(x)
         integer, intent(inout) :: x
         x=2*x
      end subroutine sub_int_inout    
      
       subroutine sub_real_inout(x)
         real, intent(inout) :: x
         x=2*x
      end subroutine sub_real_inout   
      
      subroutine sub_exp_inout(x)
         integer,dimension(5),intent(inout) :: x
         x=2*x
      end subroutine sub_exp_inout   
      
      subroutine sub_multi_inout(x,y,z)
         integer, intent(in) :: x
         integer, intent(inout) :: y
         integer, intent(out) :: z
         y=y*x
         z=y*x
      end subroutine sub_multi_inout  
      
      subroutine sub_int_no_intent(x)
         integer :: x
         x=2*x
      end subroutine sub_int_no_intent 
      
      integer function func_int_in(x)
         integer, intent(in) ::x
         func_int_in=2*x
      end function func_int_in
      
      integer function func_int_in_multi(x,y,z)
         integer, intent(in) ::x,y,z
         func_int_in_multi=x+y+z
      end function func_int_in_multi
      
      subroutine sub_str_in_explicit(x)
         character(len=10), intent(in) ::x
         write(output_unit,*) trim(x)
      end subroutine sub_str_in_explicit
      
      subroutine sub_str_in_implicit(x)
         character(len=*), intent(in) ::x
         write(output_unit,*) trim(x)
      end subroutine sub_str_in_implicit
      
      subroutine sub_str_multi(x,y,z)
         integer, intent(in) ::x,z
         character(len=*), intent(in) ::y
         write(output_unit,'(I1,1X,A)') x+z,trim(y)
      end subroutine sub_str_multi
      
      subroutine sub_alter_mod()
         a_int=99
         a_int_lp=99_lp
         a_real=99.0
         a_real_dp=99.0_dp
         a_real_qp=99.0_qp
         a_str="9999999999"
         a_cmplx=(99.0,99.0)
         a_cmplx_dp=(99.0_dp,99.0_dp)
         a_cmplx_qp=(00.0_qp,99.0_qp)
      end subroutine sub_alter_mod
      
   
      subroutine sub_alloc_int_1d_arrs()
      
         if(.not. allocated(c_int_alloc_1d)) allocate(c_int_alloc_1d(5))
         if(.not. allocated(c_int_alloc_2d)) allocate(c_int_alloc_2d(5,5))
         if(.not. allocated(c_int_alloc_3d)) allocate(c_int_alloc_3d(5,5,5))
         if(.not. allocated(c_int_alloc_4d)) allocate(c_int_alloc_4d(5,5,5,5))
         if(.not. allocated(c_int_alloc_5d)) allocate(c_int_alloc_5d(5,5,5,5,5))
         
         c_int_alloc_1d=1
         c_int_alloc_2d=1
         c_int_alloc_3d=1
         c_int_alloc_4d=1  
         c_int_alloc_5d=1
      
      end subroutine sub_alloc_int_1d_arrs
      
      
      subroutine sub_alloc_int_1d_cleanup()
      
         if(allocated(c_int_alloc_1d)) deallocate(c_int_alloc_1d)
         if(allocated(c_int_alloc_2d)) deallocate(c_int_alloc_2d)
         if(allocated(c_int_alloc_3d)) deallocate(c_int_alloc_3d)
         if(allocated(c_int_alloc_4d)) deallocate(c_int_alloc_4d)
         if(allocated(c_int_alloc_5d)) deallocate(c_int_alloc_5d)

      end subroutine sub_alloc_int_1d_cleanup     
      
      
      subroutine sub_alloc_real_1d_arrs()
      
         if(.not. allocated(c_real_alloc_1d)) allocate(c_real_alloc_1d(5))
         if(.not. allocated(c_real_alloc_2d)) allocate(c_real_alloc_2d(5,5))
         if(.not. allocated(c_real_alloc_3d)) allocate(c_real_alloc_3d(5,5,5))
         if(.not. allocated(c_real_alloc_4d)) allocate(c_real_alloc_4d(5,5,5,5))
         if(.not. allocated(c_real_alloc_5d)) allocate(c_real_alloc_5d(5,5,5,5,5))
         
         c_real_alloc_1d=1
         c_real_alloc_2d=1
         c_real_alloc_3d=1
         c_real_alloc_4d=1  
         c_real_alloc_5d=1
      
      end subroutine sub_alloc_real_1d_arrs
      
      
      subroutine sub_alloc_real_1d_cleanup()
      
         if(allocated(c_real_alloc_1d)) deallocate(c_real_alloc_1d)
         if(allocated(c_real_alloc_2d)) deallocate(c_real_alloc_2d)
         if(allocated(c_real_alloc_3d)) deallocate(c_real_alloc_3d)
         if(allocated(c_real_alloc_4d)) deallocate(c_real_alloc_4d)
         if(allocated(c_real_alloc_5d)) deallocate(c_real_alloc_5d)

      end subroutine sub_alloc_real_1d_cleanup  
   
      subroutine sub_alloc_real_dp_1d_arrs()
      
         if(.not. allocated(c_real_dp_alloc_1d)) allocate(c_real_dp_alloc_1d(5))
         if(.not. allocated(c_real_dp_alloc_2d)) allocate(c_real_dp_alloc_2d(5,5))
         if(.not. allocated(c_real_dp_alloc_3d)) allocate(c_real_dp_alloc_3d(5,5,5))
         if(.not. allocated(c_real_dp_alloc_4d)) allocate(c_real_dp_alloc_4d(5,5,5,5))
         if(.not. allocated(c_real_dp_alloc_5d)) allocate(c_real_dp_alloc_5d(5,5,5,5,5))
         
         c_real_dp_alloc_1d=1
         c_real_dp_alloc_2d=1
         c_real_dp_alloc_3d=1
         c_real_dp_alloc_4d=1  
         c_real_dp_alloc_5d=1
      
      end subroutine sub_alloc_real_dp_1d_arrs
      
      
      subroutine sub_alloc_real_dp_1d_cleanup()
      
         if(allocated(c_real_dp_alloc_1d)) deallocate(c_real_dp_alloc_1d)
         if(allocated(c_real_dp_alloc_2d)) deallocate(c_real_dp_alloc_2d)
         if(allocated(c_real_dp_alloc_3d)) deallocate(c_real_dp_alloc_3d)
         if(allocated(c_real_dp_alloc_4d)) deallocate(c_real_dp_alloc_4d)
         if(allocated(c_real_dp_alloc_5d)) deallocate(c_real_dp_alloc_5d)

      end subroutine sub_alloc_real_dp_1d_cleanup  
      
      
      subroutine sub_exp_array_int_1d(x)
         integer,dimension(5), intent(in) :: x
         
         write(output_unit,'(5(I1,1X))') x
      end subroutine sub_exp_array_int_1d

      subroutine sub_exp_array_int_2d(x)
         integer,dimension(5,5), intent(in) :: x
         integer :: i,j,k
         write(output_unit,'(25(I2.2,1X))') x
      end subroutine sub_exp_array_int_2d
      
      subroutine sub_exp_array_int_3d(x)
         integer,dimension(5,5,5), intent(in) :: x
         write(output_unit,'(125(I3.3,1X))') x
      end subroutine sub_exp_array_int_3d
      
      subroutine sub_exp_array_real_1d(x)
         real,dimension(5), intent(in) :: x
         write(output_unit,'(5(F5.1,1X))') x
      end subroutine sub_exp_array_real_1d
  
      subroutine sub_exp_array_real_2d(x)
         real,dimension(5,5), intent(in) :: x
         write(output_unit,'(25(F5.1,1X))') x
      end subroutine sub_exp_array_real_2d  
      
      subroutine sub_exp_array_real_3d(x)
         real,dimension(5,5,5), intent(in) :: x
         write(output_unit,'(125(F5.1,1X))') x
      end subroutine sub_exp_array_real_3d
      
      subroutine sub_exp_array_real_dp_1d(x)
         real(dp),dimension(5), intent(in) :: x
         write(output_unit,'(5(F5.1,1X))') x
      end subroutine sub_exp_array_real_dp_1d
  
      subroutine sub_exp_array_real_dp_2d(x)
         real(dp),dimension(5,5), intent(in) :: x
         write(output_unit,'(25(F5.1,1X))') x
      end subroutine sub_exp_array_real_dp_2d  
      
      subroutine sub_exp_array_real_dp_3d(x)
         real(dp),dimension(5,5,5), intent(in) :: x
         write(output_unit,'(125(F5.1,1X))') x
      end subroutine sub_exp_array_real_dp_3d
    
      subroutine sub_exp_array_int_1d_multi(y,x,z)
         integer,dimension(5), intent(in) :: x
         integer,intent(in) :: y,z
         
         write(output_unit,'(I2,1X,5(I1,1X),I2,1X)') y,x,z
      end subroutine sub_exp_array_int_1d_multi
      
      logical function func_return_res(x) result(res1)
         integer, intent(in) :: x
         res1 =.false.
         if(x==2) res1 = .true.
      end function func_return_res
      
      logical function func_alltrue_arr_1d(x) result(res2)
         logical, dimension(:), intent(in) :: x
         res2 =.false.
         if(all(x.eqv..true.)) res2 = .true.
!         write(*,*) "1",x,"*",res2
      end function func_alltrue_arr_1d
      
      logical function func_allfalse_arr_1d(x) result(res2)
         logical, dimension(:), intent(in) :: x
         res2 =.false.
         if(all(x.eqv..false.)) res2 = .true.
!         write(*,*) "2",x,"*",res2
      end function func_allfalse_arr_1d
      
      logical function func_allfalse_arr_1d_inout(x) result(res2)
         logical, dimension(:), intent(inout) :: x
         res2 =.false.
         if(all(x.eqv..false.)) res2 = .true.
         x=.True.
      end function func_allfalse_arr_1d_inout
      
      
      logical function func_assumed_shape_arr_1d(x) result(res2)
         integer, dimension(:), intent(inout) :: x
         res2 =.false.
         if(x(1)==2) res2 = .true.
      end function func_assumed_shape_arr_1d
      
      logical function func_assumed_shape_arr_2d(x) result(res3)
         integer, dimension(:,:), intent(inout) :: x
         res3 =.false.
         if(x(2,1)==2) res3 = .true.
      end function func_assumed_shape_arr_2d
      
      logical function func_assumed_shape_arr_3d(x) result(res4)
         integer, dimension(:,:,:), intent(inout) :: x
         res4 =.false.
         if(x(3,2,1)==2) res4 = .true.
      end function func_assumed_shape_arr_3d
      
      logical function func_assumed_shape_arr_4d(x) result(res5)
         integer, dimension(:,:,:,:), intent(inout) :: x
         res5 =.false.
         if(x(4,3,2,1)==2) res5 = .true.
      end function func_assumed_shape_arr_4d
      
      logical function func_assumed_shape_arr_5d(x) result(res6)
         integer, dimension(:,:,:,:,:), intent(inout) :: x
         res6 =.false.
         if(x(5,4,3,2,1)==2) res6 = .true.
      end function func_assumed_shape_arr_5d
      

      logical function func_assumed_size_arr_1d(x) result(res7)
         integer, intent(inout) :: x(*)
         res7 =.false.
         if(x(2)==2) res7 = .true.
      end function func_assumed_size_arr_1d
   
 
      logical function func_assumed_size_arr_real_1d(x) result(res8)
         real, intent(inout) :: x(*)
         res8 =.false.
         if(x(2)==2) res8 = .true.
      end function func_assumed_size_arr_real_1d
      
      logical function func_assumed_size_arr_real_dp_1d(x) result(res9)
         real(dp), intent(inout) :: x(*)
         res9 =.false.
         if(x(2)==2) res9 = .true.
      end function func_assumed_size_arr_real_dp_1d 
      
      subroutine sub_alloc_arr_1d(x)
         integer, dimension(:),allocatable, intent(inout) :: x
         
         allocate(x(1:10))
         x=10

      end subroutine sub_alloc_arr_1d
      
      subroutine sub_f_simple_in(x)
         type(s_simple), intent(in) :: x
         
         write(output_unit,'(2(I2,1X))') x%x,x%y
      end subroutine sub_f_simple_in
      
      subroutine sub_f_simple_out(x)
         type(s_simple), intent(out) :: x
         
         x%x=1
         x%y=10
      end subroutine sub_f_simple_out
      
      subroutine sub_f_simple_inout(zzz)
         type(s_simple), intent(inout) :: zzz
         
         write(output_unit,'(2(I2,1X))') zzz%x,zzz%y
         zzz%x=1
         zzz%y=10
      end subroutine sub_f_simple_inout
      
      subroutine sub_f_simple_inoutp(zzz)
         type(s_simple),pointer, intent(inout) :: zzz
         
         write(output_unit,'(2(I2,1X))') zzz%x,zzz%y
         zzz%x=1
         zzz%y=10
      end subroutine sub_f_simple_inoutp
      
      subroutine sub_int_p(zzz)
         integer,pointer, intent(inout) :: zzz
         
         write(output_unit,'(I2)') zzz
         
         zzz = 5
      end subroutine sub_int_p
      
      subroutine sub_real_p(zzz)
         real,pointer, intent(inout) :: zzz
         
         write(output_unit,'(F5.2)') zzz
         
         zzz = 5.0
      end subroutine sub_real_p
      
      subroutine sub_str_p(zzz)
         character(len=*),pointer, intent(inout) :: zzz
         
         write(output_unit,'(A)') zzz
         
         zzz = 'xyzxyz'
      end subroutine sub_str_p
      
      subroutine sub_arr_assumed_rank_int_1d(zzz)
         real,dimension(:),pointer, intent(inout) :: zzz
         
         write(*,*) zzz(1:5)
         zzz(1:5) = 100.0
      end subroutine sub_arr_assumed_rank_int_1d
      
      
      subroutine sub_int_opt(x)
         integer, optional, intent(in) :: x
         
         if(present(x)) then
            write(*,*) 100
         else
            write(*,*) 200
         end if  
      end subroutine sub_int_opt

      logical function func_check_nested_dt() result(res10)
         res10=.false.
         if(g_struct%a_int==10 .and. &
            g_struct%f_struct%a_int==8) res10=.True.
      end function func_check_nested_dt      
      
      subroutine sub_use_mod()
      
         test2_x = 1
         f_struct_simple2%x = 5
         f_struct_simple2%y = 6
      
      end subroutine sub_use_mod
      
      
end module tester

! SPDX-License-Identifier: GPL-2.0+

module namelist

	use iso_fortran_env, only: output_unit, real128
	
	implicit none
	
	! Parameters
	integer, parameter :: dp = selected_real_kind(p=15)
	integer, parameter :: qp = selected_real_kind(p=30)
	integer, parameter :: lp = selected_int_kind(8)
	

	integer :: a_int
	real :: b_real
	real(dp) :: b_real_dp
	character(len=100) :: c_str

	namelist /namelist1/ a_int, b_real, b_real_dp, c_str

	
	contains



end module namelist
 

! SPDX-License-Identifier: GPL-2.0+

module pdt

	use iso_fortran_env, only: output_unit, real128
	
	implicit none
	
	! Parameters
	integer, parameter :: sp = selected_real_kind(p=8)
	integer, parameter :: dp = selected_real_kind(p=15)
	integer, parameter :: qp = selected_real_kind(p=30)
	integer, parameter :: lp = selected_int_kind(8)
	
	
	type pdt_def(k,a)
		integer, kind :: k = sp 
		integer, len :: a
		real(k) :: array(a,a)
	
	end type pdt_def
	
	
	type (pdt_def(dp,3)) :: pdt_dp_3
	type (pdt_def(sp,3)) :: pdt_sp_3
	
	
	contains


	subroutine sub_write_pdt()
	
		write(*,*) pdt_dp_3%array
	
	end subroutine sub_write_pdt
	
	subroutine sub_pdt()
		type (pdt_def(lp,5)) :: x
		
		x%array = 2
	end subroutine sub_pdt

end module pdt

   

! SPDX-License-Identifier: GPL-2.0+

module gh55

	use iso_fortran_env, only: output_unit, real128
	
	implicit none
	
	! Parameters
	integer, parameter :: dp = selected_real_kind(p=15)
	integer, parameter :: qp = selected_real_kind(p=30)
	integer, parameter :: lp = selected_int_kind(16)
	
	
	contains

	recursive function return_char(x) result(str)
		integer, intent(in) :: x
		character(len=10), dimension((2 ** x - 1) ) :: str

		str = ''
		str(2**x-1) = 'abcdefghil'
	
	end function return_char

end module gh55

        

module memory_leak

    use, intrinsic :: iso_fortran_env
    
    implicit none

    public

    type d_params
        
        integer simType           
        real l0
        real, dimension(3, 4) :: cdims
        logical field_int_on_currently

    end type

contains

        subroutine set_param_defaults(alloc_test, xlc_p)
                
               implicit none
        
                integer :: I,J, flag
                real, intent(inout), allocatable :: alloc_test(:,:)
                type(d_params), intent(inout) :: xlc_p
       
		alloc_test(1,1) = alloc_test(1,1) + 1

        end subroutine set_param_defaults

end module memory_leak

! SPDX-License-Identifier: GPL-2.0+
! This file is auto generated do not edit by hand
module vars_modules
    implicit none

    integer, parameter :: r4 = selected_real_kind(4)
    integer, parameter :: r8 = selected_real_kind(8)
    integer, parameter :: r16 = selected_real_kind(32)

    integer, parameter :: i1 = selected_int_kind(1)
    integer, parameter :: i2 = selected_int_kind(2)
    integer, parameter :: i4 = selected_int_kind(4)
    integer, parameter :: i8 = selected_int_kind(8)

    integer, parameter :: c1 = selected_char_kind ("ascii")
    integer, parameter :: c4  = selected_char_kind ('ISO_10646')
 

    integer(i1) :: int_i1_0 = -1_i1 

    integer(i1) :: int_i1_1 = 0_i1 

    integer(i1) :: int_i1_2 = 1_i1 

    integer(i2) :: int_i2_0 = -1_i2 

    integer(i2) :: int_i2_1 = 0_i2 

    integer(i2) :: int_i2_2 = 1_i2 

    integer(i4) :: int_i4_0 = -1_i4 

    integer(i4) :: int_i4_1 = 0_i4 

    integer(i4) :: int_i4_2 = 1_i4 

    integer(i8) :: int_i8_0 = -1_i8 

    integer(i8) :: int_i8_1 = 0_i8 

    integer(i8) :: int_i8_2 = 1_i8 

    real(r4) :: real_r4_0 = -3.140000104904175_r4 

    real(r4) :: real_r4_1 = 0_r4 

    real(r4) :: real_r4_2 = 3.140000104904175_r4 

    real(r8) :: real_r8_0 = -3.140000104904175_r8 

    real(r8) :: real_r8_1 = 0_r8 

    real(r8) :: real_r8_2 = 3.140000104904175_r8 

    
contains

 

    function check_int_i1_0() result(x) 
    implicit none
    logical :: x
    x = .false.
    if(int_i1_0/=-2_i1) return
    x = .true.
    end function check_int_i1_0 

    function check_int_i1_1() result(x) 
    implicit none
    logical :: x
    x = .false.
    if(int_i1_1/=0_i1) return
    x = .true.
    end function check_int_i1_1 

    function check_int_i1_2() result(x) 
    implicit none
    logical :: x
    x = .false.
    if(int_i1_2/=2_i1) return
    x = .true.
    end function check_int_i1_2 

    function check_int_i2_0() result(x) 
    implicit none
    logical :: x
    x = .false.
    if(int_i2_0/=-2_i2) return
    x = .true.
    end function check_int_i2_0 

    function check_int_i2_1() result(x) 
    implicit none
    logical :: x
    x = .false.
    if(int_i2_1/=0_i2) return
    x = .true.
    end function check_int_i2_1 

    function check_int_i2_2() result(x) 
    implicit none
    logical :: x
    x = .false.
    if(int_i2_2/=2_i2) return
    x = .true.
    end function check_int_i2_2 

    function check_int_i4_0() result(x) 
    implicit none
    logical :: x
    x = .false.
    if(int_i4_0/=-2_i4) return
    x = .true.
    end function check_int_i4_0 

    function check_int_i4_1() result(x) 
    implicit none
    logical :: x
    x = .false.
    if(int_i4_1/=0_i4) return
    x = .true.
    end function check_int_i4_1 

    function check_int_i4_2() result(x) 
    implicit none
    logical :: x
    x = .false.
    if(int_i4_2/=2_i4) return
    x = .true.
    end function check_int_i4_2 

    function check_int_i8_0() result(x) 
    implicit none
    logical :: x
    x = .false.
    if(int_i8_0/=-2_i8) return
    x = .true.
    end function check_int_i8_0 

    function check_int_i8_1() result(x) 
    implicit none
    logical :: x
    x = .false.
    if(int_i8_1/=0_i8) return
    x = .true.
    end function check_int_i8_1 

    function check_int_i8_2() result(x) 
    implicit none
    logical :: x
    x = .false.
    if(int_i8_2/=2_i8) return
    x = .true.
    end function check_int_i8_2 

    function check_real_r4_0() result(x) 
    implicit none
    logical :: x
    x = .false.
    if(real_r4_0/=-6.28000020980835_r4) return
    x = .true.
    end function check_real_r4_0 

    function check_real_r4_1() result(x) 
    implicit none
    logical :: x
    x = .false.
    if(real_r4_1/=0_r4) return
    x = .true.
    end function check_real_r4_1 

    function check_real_r4_2() result(x) 
    implicit none
    logical :: x
    x = .false.
    if(real_r4_2/=6.28000020980835_r4) return
    x = .true.
    end function check_real_r4_2 

    function check_real_r8_0() result(x) 
    implicit none
    logical :: x
    x = .false.
    if(real_r8_0/=-6.28000020980835_r8) return
    x = .true.
    end function check_real_r8_0 

    function check_real_r8_1() result(x) 
    implicit none
    logical :: x
    x = .false.
    if(real_r8_1/=0_r8) return
    x = .true.
    end function check_real_r8_1 

    function check_real_r8_2() result(x) 
    implicit none
    logical :: x
    x = .false.
    if(real_r8_2/=6.28000020980835_r8) return
    x = .true.
    end function check_real_r8_2 

end module vars_modules
 

! SPDX-License-Identifier: GPL-2.0+

module dummy_arrays

	use iso_fortran_env, only: output_unit, real128
	
	implicit none
	
	! Parameters
	integer, parameter :: dp = selected_real_kind(p=15)
	integer, parameter :: qp = selected_real_kind(p=30)
	integer, parameter :: lp = selected_int_kind(8)
	
	integer, allocatable, dimension(:) :: c_int_alloc_1d
	integer, allocatable, dimension(:,:) :: c_int_alloc_2d
	integer, allocatable, dimension(:,:,:) :: c_int_alloc_3d
	integer, allocatable, dimension(:,:,:,:) :: c_int_alloc_4d
	integer, allocatable, dimension(:,:,:,:,:) :: c_int_alloc_5d
	
	real, allocatable, dimension(:) :: c_real_alloc_1d
	real, allocatable, dimension(:,:) :: c_real_alloc_2d
	real, allocatable, dimension(:,:,:) :: c_real_alloc_3d
	real, allocatable, dimension(:,:,:,:) :: c_real_alloc_4d
	real, allocatable, dimension(:,:,:,:,:) :: c_real_alloc_5d
	
	real(dp), allocatable, dimension(:) :: c_real_dp_alloc_1d
	real(dp), allocatable, dimension(:,:) :: c_real_dp_alloc_2d
	real(dp), allocatable, dimension(:,:,:) :: c_real_dp_alloc_3d
	real(dp), allocatable, dimension(:,:,:,:) :: c_real_dp_alloc_4d
	real(dp), allocatable, dimension(:,:,:,:,:) :: c_real_dp_alloc_5d
	
	
	integer, pointer, dimension(:) :: d_int_point_1d => null()
	integer, pointer, dimension(:,:) :: d_int_point_2d => null()
	integer, pointer, dimension(:,:,:) :: d_int_point_3d => null()
	integer, pointer, dimension(:,:,:,:) :: d_int_point_4d => null()
	integer, pointer, dimension(:,:,:,:,:) :: d_int_point_5d => null()
	
	real, pointer, dimension(:) :: d_real_point_1d => null()
	real, pointer, dimension(:,:) :: d_real_point_2d => null()
	real, pointer, dimension(:,:,:) :: d_real_point_3d => null()
	real, pointer, dimension(:,:,:,:) :: d_real_point_4d => null()
	real, pointer, dimension(:,:,:,:,:) :: d_real_point_5d => null()
	
	real(dp), pointer, dimension(:) :: d_real_dp_point_1d => null()
	real(dp), pointer, dimension(:,:) :: d_real_dp_point_2d => null()
	real(dp), pointer, dimension(:,:,:) :: d_real_dp_point_3d => null()
	real(dp), pointer, dimension(:,:,:,:) :: d_real_dp_point_4d => null()
	real(dp), pointer, dimension(:,:,:,:,:) :: d_real_dp_point_5d => null()
	
	integer, target, dimension(5) :: e_int_target_1d
	integer, target, dimension(5,5) :: e_int_target_2d
	integer, target, dimension(5,5,5) :: e_int_target_3d
	integer, target, dimension(5,5,5,5) :: e_int_target_4d
	integer, target, dimension(5,5,5,5,5) :: e_int_target_5d
	
	real, target, dimension(5) :: e_real_target_1d
	real, target, dimension(5,5) :: e_real_target_2d
	real, target, dimension(5,5,5) :: e_real_target_3d
	real, target, dimension(5,5,5,5) :: e_real_target_4d
	real, target, dimension(5,5,5,5,5) :: e_real_target_5d
	
	real(dp), target, dimension(5) :: e_real_dp_target_1d
	real(dp), target, dimension(5,5) :: e_real_dp_target_2d
	real(dp), target, dimension(5,5,5) :: e_real_dp_target_3d
	real(dp), target, dimension(5,5,5,5) :: e_real_dp_target_4d
	real(dp), target, dimension(5,5,5,5,5) :: e_real_dp_target_5d
	
	
	character(len=10), allocatable, dimension(:) :: c_str_alloc_1d
	character(len=10), allocatable, dimension(:,:) :: c_str_alloc_2d
	character(len=10), allocatable, dimension(:,:,:) :: c_str_alloc_3d
	character(len=10), allocatable, dimension(:,:,:,:) :: c_str_alloc_4d
	character(len=10), allocatable, dimension(:,:,:,:,:) :: c_str_alloc_5d     

	
	contains
	
	
	subroutine sub_alloc_int_1d_arrs()
	
		if(.not. allocated(c_int_alloc_1d)) allocate(c_int_alloc_1d(5))
		if(.not. allocated(c_int_alloc_2d)) allocate(c_int_alloc_2d(5,5))
		if(.not. allocated(c_int_alloc_3d)) allocate(c_int_alloc_3d(5,5,5))
		if(.not. allocated(c_int_alloc_4d)) allocate(c_int_alloc_4d(5,5,5,5))
		if(.not. allocated(c_int_alloc_5d)) allocate(c_int_alloc_5d(5,5,5,5,5))
		
		c_int_alloc_1d=1
		c_int_alloc_2d=1
		c_int_alloc_3d=1
		c_int_alloc_4d=1  
		c_int_alloc_5d=1
	
	end subroutine sub_alloc_int_1d_arrs

	subroutine print_c_int_alloc_1d()
		write(*,*) c_int_alloc_1d
	end subroutine print_c_int_alloc_1d
	
	
	subroutine sub_alloc_int_1d_cleanup()
	
		if(allocated(c_int_alloc_1d)) deallocate(c_int_alloc_1d)
		if(allocated(c_int_alloc_2d)) deallocate(c_int_alloc_2d)
		if(allocated(c_int_alloc_3d)) deallocate(c_int_alloc_3d)
		if(allocated(c_int_alloc_4d)) deallocate(c_int_alloc_4d)
		if(allocated(c_int_alloc_5d)) deallocate(c_int_alloc_5d)
	
	end subroutine sub_alloc_int_1d_cleanup   
	
	
	subroutine sub_alter_int_1d()
	
		write(*,*) c_int_alloc_1d
		c_int_alloc_1d = 5
		write(*,*) c_int_alloc_1d
	
	end subroutine sub_alter_int_1d  
	
	
	subroutine sub_alloc_real_1d_arrs()
	
		if(.not. allocated(c_real_alloc_1d)) allocate(c_real_alloc_1d(5))
		if(.not. allocated(c_real_alloc_2d)) allocate(c_real_alloc_2d(5,5))
		if(.not. allocated(c_real_alloc_3d)) allocate(c_real_alloc_3d(5,5,5))
		if(.not. allocated(c_real_alloc_4d)) allocate(c_real_alloc_4d(5,5,5,5))
		if(.not. allocated(c_real_alloc_5d)) allocate(c_real_alloc_5d(5,5,5,5,5))
		
		c_real_alloc_1d=1
		c_real_alloc_2d=1
		c_real_alloc_3d=1
		c_real_alloc_4d=1  
		c_real_alloc_5d=1
	
	end subroutine sub_alloc_real_1d_arrs
	
	
	subroutine sub_alloc_real_1d_cleanup()
	
		if(allocated(c_real_alloc_1d)) deallocate(c_real_alloc_1d)
		if(allocated(c_real_alloc_2d)) deallocate(c_real_alloc_2d)
		if(allocated(c_real_alloc_3d)) deallocate(c_real_alloc_3d)
		if(allocated(c_real_alloc_4d)) deallocate(c_real_alloc_4d)
		if(allocated(c_real_alloc_5d)) deallocate(c_real_alloc_5d)
	
	end subroutine sub_alloc_real_1d_cleanup  
	
	subroutine sub_alloc_real_dp_1d_arrs()
	
		if(.not. allocated(c_real_dp_alloc_1d)) allocate(c_real_dp_alloc_1d(5))
		if(.not. allocated(c_real_dp_alloc_2d)) allocate(c_real_dp_alloc_2d(5,5))
		if(.not. allocated(c_real_dp_alloc_3d)) allocate(c_real_dp_alloc_3d(5,5,5))
		if(.not. allocated(c_real_dp_alloc_4d)) allocate(c_real_dp_alloc_4d(5,5,5,5))
		if(.not. allocated(c_real_dp_alloc_5d)) allocate(c_real_dp_alloc_5d(5,5,5,5,5))
		
		c_real_dp_alloc_1d=1
		c_real_dp_alloc_2d=1
		c_real_dp_alloc_3d=1
		c_real_dp_alloc_4d=1  
		c_real_dp_alloc_5d=1
	
	end subroutine sub_alloc_real_dp_1d_arrs
	
	
	subroutine sub_alloc_real_dp_1d_cleanup()
	
		if(allocated(c_real_dp_alloc_1d)) deallocate(c_real_dp_alloc_1d)
		if(allocated(c_real_dp_alloc_2d)) deallocate(c_real_dp_alloc_2d)
		if(allocated(c_real_dp_alloc_3d)) deallocate(c_real_dp_alloc_3d)
		if(allocated(c_real_dp_alloc_4d)) deallocate(c_real_dp_alloc_4d)
		if(allocated(c_real_dp_alloc_5d)) deallocate(c_real_dp_alloc_5d)
	
	end subroutine sub_alloc_real_dp_1d_cleanup  


	logical function func_alltrue_arr_1d(x) result(res2)
		logical, dimension(:), intent(in) :: x
		res2 =.false.
		if(all(x.eqv..true.)) res2 = .true.
		!         write(*,*) "1",x,"*",res2
		end function func_alltrue_arr_1d
	
	logical function func_allfalse_arr_1d(x) result(res2)
		logical, dimension(:), intent(in) :: x
		res2 =.false.
		if(all(x.eqv..false.)) res2 = .true.
		!         write(*,*) "2",x,"*",res2
	end function func_allfalse_arr_1d
	
	logical function func_allfalse_arr_1d_inout(x) result(res2)
		logical, dimension(:), intent(inout) :: x
		res2 =.false.
		if(all(x.eqv..false.)) res2 = .true.
		x=.True.
	end function func_allfalse_arr_1d_inout
	
	
	logical function func_assumed_shape_arr_1d(x) result(res2)
		integer, dimension(:), intent(inout) :: x
		res2 =.false.
		if(x(1)==2) res2 = .true.
		x=9
	end function func_assumed_shape_arr_1d
	
	logical function func_assumed_shape_arr_2d(x) result(res3)
		integer, dimension(:,:), intent(inout) :: x
		res3 =.false.
		if(x(2,1)==2) res3 = .true.
	end function func_assumed_shape_arr_2d
	
	logical function func_assumed_shape_arr_3d(x) result(res4)
		integer, dimension(:,:,:), intent(inout) :: x
		res4 =.false.
		if(x(3,2,1)==2) res4 = .true.
	end function func_assumed_shape_arr_3d
	
	logical function func_assumed_shape_arr_4d(x) result(res5)
		integer, dimension(:,:,:,:), intent(inout) :: x
		res5 =.false.
		if(x(4,3,2,1)==2) res5 = .true.
	end function func_assumed_shape_arr_4d
	
	logical function func_assumed_shape_arr_5d(x) result(res6)
		integer, dimension(:,:,:,:,:), intent(inout) :: x
		res6 =.false.
		if(x(5,4,3,2,1)==2) res6 = .true.
	end function func_assumed_shape_arr_5d
	
	
	logical function func_assumed_size_arr_1d(x) result(res7)
		integer, intent(inout) :: x(*)
		res7 =.false.
		if(x(2)==2) res7 = .true.
	end function func_assumed_size_arr_1d
	
	
	logical function func_assumed_size_arr_real_1d(x) result(res8)
		real, intent(inout) :: x(*)
		res8 =.false.
		if(x(2)==2) res8 = .true.
	end function func_assumed_size_arr_real_1d
	
	logical function func_assumed_size_arr_real_dp_1d(x) result(res9)
		real(dp), intent(inout) :: x(*)
		res9 =.false.
		if(x(2)==2) res9 = .true.
	end function func_assumed_size_arr_real_dp_1d 
	
	subroutine sub_alloc_arr_1d(x)
		integer, dimension(:),allocatable, intent(inout) :: x
		
		allocate(x(1:10))
		x=10
		
	end subroutine sub_alloc_arr_1d
	
	
	
	subroutine sub_arr_assumed_rank_int_1d(zzz)
		integer,dimension(:),pointer, intent(inout) :: zzz
		
		write(*,*) zzz(1:5)
		zzz(1:5) = 100
	end subroutine sub_arr_assumed_rank_int_1d
	
	subroutine sub_arr_assumed_rank_real_1d(zzz)
		real,dimension(:),pointer, intent(inout) :: zzz
		
		write(*,*) zzz(1:5)
		zzz(1:5) = 100.0
	end subroutine sub_arr_assumed_rank_real_1d
	
	subroutine sub_arr_assumed_rank_dp_1d(zzz)
		real(dp),dimension(:),pointer, intent(inout) :: zzz
		
		write(*,*) zzz(1:5),lbound(zzz),ubound(zzz),size(zzz)
		zzz(1:4) = 100.0_dp
		zzz(5) = 100_dp
	end subroutine sub_arr_assumed_rank_dp_1d



	subroutine sub_check_alloc_int_2d(x)
		integer, allocatable,dimension(:,:), intent(inout) :: x
		integer :: i,j
		
		if(.not.allocated(x)) allocate(x(3,4))
	
		do i=1,3
			do j=1,4
				x(i,j) = j + (i-1)*4
			 end do
		end do
	
	end subroutine sub_check_alloc_int_2d


	subroutine sub_check_alloc_int_3d(x)
		integer, allocatable,dimension(:,:,:), intent(inout) :: x
		integer :: i,j, k
		
		if(.not.allocated(x)) allocate(x(3,4,5))
	
		do i=1,3
			do j=1,4
				do k=1,5
					x(i,j,k) = k + (j-1)*4 + (i-1)*4 
				end do
			 end do
		end do
	
	end subroutine sub_check_alloc_int_3d


	function func_return_alloc_int_1d() result(v)

		integer,allocatable,dimension(:) :: v

		allocate(v(5))

		v = 1

	end function func_return_alloc_int_1d


	subroutine func2
		integer,allocatable,dimension(:) :: v

		v = func_return_alloc_int_1d()

	end subroutine func2

end module dummy_arrays

! SPDX-License-Identifier: GPL-2.0+

module quad
	use iso_fortran_env, only: output_unit, real128

	implicit none
	
	     ! Parameters
		integer, parameter :: dp = selected_real_kind(p=15)
		integer, parameter :: qp = selected_real_kind(p=30)
		integer, parameter :: lp = selected_int_kind(16)
		
#ifdef __GFC_REAL_16__
    
		real(qp), parameter :: const_real_qp=1.0_qp

		real(qp)          :: a_real_qp
		
		! Set variables
		real(qp)          :: a_real_qp_set=9.0_qp

		complex(qp), parameter  :: const_cmplx_qp=(1.0_qp,1.0_qp)
		complex(qp)       :: a_cmplx_qp
		complex(qp)       :: a_cmplx_qp_set

        real(qp),pointer           :: a_real_qp_point => null()
        
        real(qp),target           :: a_real_qp_target

		
	contains
		
		subroutine sub_alter_mod()
			a_real_qp=99.0_qp
		end subroutine sub_alter_mod
      
		logical function func_check_mod()
			func_check_mod = .false.
		
			if(a_real_qp==5.0_qp) then
			    
			    func_check_mod = .true.
			end if

		end function func_check_mod
      		
		subroutine sub_test_quad(y,x)
			real(qp), intent(in) :: y
			real(qp), intent(out) :: x
		
			x = y * 3
		
		end subroutine sub_test_quad


		real(qp) function func_test_quad_ret()
			
			func_test_quad_ret = 3.14_qp

		end function  func_test_quad_ret

#endif

end module quad

! SPDX-License-Identifier: GPL-2.0+

module proc_ptrs
    use iso_fortran_env, only: output_unit, real128
    
    implicit none
    
    ! Parameters
    integer, parameter :: dp = selected_real_kind(p=15)
    integer, parameter :: qp = selected_real_kind(p=30)
    integer, parameter :: lp = selected_int_kind(8)
    
          
    procedure(func_func_run), pointer:: p_func_func_run_ptr => NULL()
    procedure(func_func_run), pointer:: p_func_func_run_ptr2 => func_func_run
    
    procedure(func_func_run_dp), pointer:: p_func_func_run_dp_ptr => NULL()


    contains
    
    
    integer function func_func_arg(func)
        integer :: func
        func_func_arg = func(1)
    end function func_func_arg
    
    
    real(dp) function func_func_arg_dp(z,func)
        integer :: z
        real(dp) :: func
        func_func_arg_dp = func(z)
    end function func_func_arg_dp
    
 
    real(dp) function func_real(x)
        integer(dp) :: x
        func_real = 100d0 * x 
    end function func_real
    
    
    integer function func_func_run(x)
        integer :: x
        !write(*,*) "x is",x,LOC(x)
        func_func_run = 10*x
        
    end function func_func_run   

    real(dp) function func_func_run_dp(x)
        real(dp) :: x
        !write(*,*) "x is",x,LOC(x)
        func_func_run_dp = 10*x
        
    end function func_func_run_dp
    
    integer function func_func_run2(x)
        integer :: x
        
        func_func_run2 = 2*x
    
    end function func_func_run2   
    
    
    integer function func_proc_ptr(x)
        integer :: x
        
        func_proc_ptr = p_func_func_run_ptr(x)
    end function func_proc_ptr
    
    subroutine sub_proc_ptr2()      
        p_func_func_run_ptr => func_func_run2
    end subroutine sub_proc_ptr2
    
    subroutine sub_null_proc_ptr()
        p_func_func_run_ptr => null()
    end subroutine sub_null_proc_ptr
    

    subroutine sub_proc_ptr_setter(x)      
        procedure(func_func_run) :: x

        p_func_func_run_ptr => x
    end subroutine sub_proc_ptr_setter

    subroutine sub_proc_ptr_setter2()      
        procedure(func_func_run), pointer:: x => func_func_run

        p_func_func_run_ptr => x
    end subroutine sub_proc_ptr_setter2

    
    integer function proc_proc_func_arg(x)
         procedure(func_func_run), pointer :: x
         
         proc_proc_func_arg = x(9)
    
    end function proc_proc_func_arg


end module proc_ptrs

! SPDX-License-Identifier: GPL-2.0+

module elements

	use iso_fortran_env, only: output_unit, real128
	
	implicit none
	
	! Parameters
	integer, parameter :: dp = selected_real_kind(p=15)
	integer, parameter :: qp = selected_real_kind(p=30)
	integer, parameter :: lp = selected_int_kind(8)
	
	
	contains


	elemental integer function ele_func_1(x)
		integer,intent(in) :: x

		ele_func_1 = x*2

	end function ele_func_1

	elemental function ele_func_res(x) result(y)
		integer,intent(in) :: x
		integer :: y

		y = x*2

	end function ele_func_res

	elemental integer function ele_func_2(x, y)
		integer,intent(in) :: x, y

		ele_func_2 = x*2 + y*2

	end function ele_func_2


	elemental subroutine ele_sub_2(x, y)
		real(dp),intent(in) :: x
		real(dp), intent(out) :: y

		y = x*3

	end subroutine ele_sub_2

	subroutine call_ele()

		integer :: x,x1(5),x2(5,5)

		x = 1
		x1 = 2
		x2 = 2

		x = ele_func_1(x)

		x1 = ele_func_1(x1)

		x2 = ele_func_1(x2)


	end subroutine call_ele


end module elements

! SPDX-License-Identifier: GPL-2.0+

module strings

	use iso_fortran_env, only: output_unit, real128
	
	implicit none
	
	! Parameters
	integer, parameter :: dp = selected_real_kind(p=15)
	integer, parameter :: qp = selected_real_kind(p=30)
	integer, parameter :: lp = selected_int_kind(8)
	
	
	character(len=10),parameter :: const_str='1234567890'
	
	character(len=10) :: a_str
	character(len=10) :: a_str_set='abcdefghjk'
	character(:), allocatable :: str_alloc


	character(len=10),dimension(5) :: a_str_exp_1d
	character(len=10),dimension(5,5) :: a_str_exp_2d
	character(len=10),dimension(5,5,5) :: a_str_exp_3d
	
	
	character(len=10),dimension(:),allocatable :: b_str_alloc_1d
	character(len=10),dimension(:,:),allocatable :: b_str_alloc_2d
	character(len=10),dimension(:,:,:),allocatable :: b_str_alloc_3d


	character(len=2),dimension(3), parameter :: a_str_p_1d = (/'aa','bb','cc'/)



	type str_array_dt
		integer :: start_guard = 123456789
		character(len=10),dimension(5) :: a_str_exp_1d
		integer :: end_guard = 123456789
	end type str_array_dt

	type str_array_dt_alloc
		integer :: start_guard = 123456789
		character(len=10),dimension(:),allocatable :: b_str_alloc_1d
		integer :: end_guard = 123456789
	end type str_array_dt_alloc


	type str_array_dt_out
		character(len=12) :: a_str1, a_str2
		integer ::  a_int
	end type str_array_dt_out

	contains
	
	subroutine sub_str_in_explicit(x)
		character(len=10), intent(in) ::x
		write(output_unit,*) trim(x)
	end subroutine sub_str_in_explicit
	
	subroutine sub_str_in_implicit(x)
		character(len=*), intent(in) ::x
		write(output_unit,*) trim(x)
	end subroutine sub_str_in_implicit
	
	subroutine sub_str_multi(x,y,z)
		integer, intent(in) ::x,z
		character(len=*), intent(in) ::y
		write(output_unit,'(I1,1X,A)') x+z,trim(y)
	end subroutine sub_str_multi
	
	subroutine sub_str_alloc(x_alloc)
		character(:), allocatable, intent(out) :: x_alloc
		x_alloc = 'abcdef'
	end subroutine sub_str_alloc
	
	subroutine sub_str_p(zzz)
		character(len=*),pointer, intent(inout) :: zzz
		
		write(output_unit,'(A)') zzz
		
		zzz = 'xyzxyz'
	end subroutine sub_str_p
      
      
	character(len=5) function func_ret_str(x)
		character(len=5) :: x
		
		func_ret_str = x
		func_ret_str(1:1) = 'A'
		
	end function func_ret_str
	
	
	logical function check_str_alloc(ver)
		integer :: ver
		
		check_str_alloc = .false.
		
		if(allocated(str_alloc)) then
		    !write(*,*) allocated(str_alloc)
			!write(*,*) str_alloc
			if(ver==1) then
				if(str_alloc(1:16)=='abcdefghijklmnop')  check_str_alloc = .true.
			else if (ver==2) then 
				if(str_alloc(1:8)=='12346578')  check_str_alloc = .true.
			end if
		end if
	
	end function check_str_alloc
	

	subroutine alter_str_alloc()
		
		str_alloc = 'qwerty'
	
	end subroutine alter_str_alloc
	

	subroutine sub_str_alloc2(x)
		character(len=:),allocatable,intent(inout) :: x
		
		if(.not.allocated(x)) then
			x='zxcvbnm'
			return
		end if

		if(allocated(x)) then
			write(*,*) "*",x,"*",len_trim(x)
			if(x == 'qwerty') then
				write(*,*) "Set 1"
				x = 'asdfghjkl'
				! write(*,*) "Set 2"
			end if
		end if
	
	end subroutine sub_str_alloc2
	

	
	function func_str_int_len(i) result(s)
		! Github issue #12
		integer, intent(in) :: i
		character(len=str_int_len(i)) :: s
		write(s, '(i0)') i
	end function func_str_int_len
		  
	pure integer function str_int_len(i) result(sz)
		! Returns the length of the string representation of 'i'
		integer, intent(in) :: i
		integer, parameter :: MAX_STR = 100
		character(MAX_STR) :: s
		! If 's' is too short (MAX_STR too small), Fortran will abort with:
		! "Fortran runtime error: End of record"
		write(s, '(i0)') i
		sz = len_trim(s)
	end function str_int_len


	subroutine str_array_inout(x)
		character(len=10),dimension(5) :: x

		integer :: i

		write(*,*) x(1:5)


		x(1) = 'zzzzzzzzzz'
		x(2) = 'yyyyyyyyyy'
		x(3) = 'qqqqqqqqqq'
		x(4) = 'wwwwwwwwww'
		x(5) = 'xxxxxxxxxx'


	end subroutine str_array_inout


	subroutine str_array_inout2(x,n)
		character(len=10),dimension(n) :: x
		integer,intent(in) :: n

		integer :: i

		write(*,*) x(1:5)


		x(1) = 'zzzzzzzzzz'
		x(2) = 'yyyyyyyyyy'
		x(3) = 'qqqqqqqqqq'
		x(4) = 'wwwwwwwwww'
		x(5) = 'xxxxxxxxxx'


	end subroutine str_array_inout2


	subroutine str_array_inout3(x)
		character(len=10),dimension(:) :: x

		integer :: i

		write(*,*) x(1:5)


		x(1) = 'zzzzzzzzzz'
		x(2) = 'yyyyyyyyyy'
		x(3) = 'qqqqqqqqqq'
		x(4) = 'wwwwwwwwww'
		x(5) = 'xxxxxxxxxx'


	end subroutine str_array_inout3


	subroutine str_array_inout4(x)
		character(len=*),dimension(5) :: x

		integer :: i

		write(*,*) x(1:5)


		x(1) = 'zzzzzzzzzz'
		x(2) = 'yyyyyyyyyy'
		x(3) = 'qqqqqqqqqq'
		x(4) = 'wwwwwwwwww'
		x(5) = 'xxxxxxxxxx'


	end subroutine str_array_inout4


	subroutine str_array_allocate(x)
		character(len=10),dimension(:),allocatable :: x

		allocate(x(5))

		x(1) = 'zzzzzzzzzz'
		x(2) = 'yyyyyyyyyy'
		x(3) = 'qqqqqqqqqq'
		x(4) = 'wwwwwwwwww'
		x(5) = 'xxxxxxxxxx'


	end subroutine str_array_allocate


	logical function func_str_array_dt(x)
		type(str_array_dt) :: x

		func_str_array_dt = .false.

		if(x%start_guard/=123456789 .or. x% end_guard/=123456789) then
			return
		end if


		if(x%a_str_exp_1d(1) /= 'zzzzzzzzzz') return
		if(x%a_str_exp_1d(2) /= 'yyyyyyyyyy') return
		if(x%a_str_exp_1d(3) /= 'qqqqqqqqqq') return
		if(x%a_str_exp_1d(4) /= 'wwwwwwwwww') return
		if(x%a_str_exp_1d(5) /= 'xxxxxxxxxx') return

		func_str_array_dt = .true.


	end function func_str_array_dt


	logical function func_str_array_dt_alloc(x)
		type(str_array_dt_alloc) :: x

		func_str_array_dt_alloc = .false.

		if(x%start_guard/=123456789 .or. x% end_guard/=123456789) then
			write(*,*) x%start_guard, x%end_guard
			return
		end if

		allocate(x% b_str_alloc_1d(5))


		x% b_str_alloc_1d(1) = 'zzzzzzzzzz'
		x% b_str_alloc_1d(2) = 'yyyyyyyyyy'
		x% b_str_alloc_1d(3) = 'qqqqqqqqqq'
		x% b_str_alloc_1d(4) = 'wwwwwwwwww'
		x% b_str_alloc_1d(5) = 'xxxxxxxxxx'

		func_str_array_dt_alloc = .true.


	end function func_str_array_dt_alloc


	subroutine check_a_str_exp_1d()


		write(*,*) a_str_exp_1d(1:5)


		a_str_exp_1d(1) = 'zzzzzzzzzz'
		a_str_exp_1d(2) = 'yyyyyyyyyy'
		a_str_exp_1d(3) = 'qqqqqqqqqq'
		a_str_exp_1d(4) = 'wwwwwwwwww'
		a_str_exp_1d(5) = 'xxxxxxxxxx'

	end subroutine check_a_str_exp_1d
		  

	subroutine alloc_b_str_alloc_1d()

		if(allocated(b_str_alloc_1d)) deallocate(b_str_alloc_1d)

		allocate(b_str_alloc_1d(5))

		b_str_alloc_1d(1) = 'zzzzzzzzzz'
		b_str_alloc_1d(2) = 'yyyyyyyyyy'
		b_str_alloc_1d(3) = 'qqqqqqqqqq'
		b_str_alloc_1d(4) = 'wwwwwwwwww'
		b_str_alloc_1d(5) = 'xxxxxxxxxx'		

	end subroutine alloc_b_str_alloc_1d


	logical function check_b_str_alloc_1d()

		check_b_str_alloc_1d  =.false.

		if(.not.allocated(b_str_alloc_1d)) return


		if(b_str_alloc_1d(1) /= 'zzzzzzzzzz') return
		if(b_str_alloc_1d(2) /= 'yyyyyyyyyy') return
		if(b_str_alloc_1d(3) /= 'qqqqqqqqqq') return
		if(b_str_alloc_1d(4) /= 'wwwwwwwwww') return
		if(b_str_alloc_1d(5) /= 'xxxxxxxxxx') return

		check_b_str_alloc_1d = .true.

	end function check_b_str_alloc_1d


	subroutine set_str_array_dt_out(x)
		type(str_array_dt_out),intent(out) :: x

		x%a_str1 = 'qwertyuiop[]'
		x%a_str2 = 'asdfghjkl;zx'

		x% a_int = 99

	end subroutine set_str_array_dt_out


end module strings

! SPDX-License-Identifier: GPL-2.0+

module smod

	use iso_fortran_env, only: output_unit, real128
	
	implicit none
	
	! Parameters
	integer, parameter :: dp = selected_real_kind(p=15)
	integer, parameter :: qp = selected_real_kind(p=30)
	integer, parameter :: lp = selected_int_kind(8)
	
	
	interface 
		module function func_smod(x,y) result(z)
			real(dp), intent(in) :: x,y
			real(dp) :: z
		end function func_smod
		
		module function func_smod2(x,y) result(z)
			real(dp), intent(in) :: x,y
			real(dp) :: z
		end function func_smod2
		
	end interface
	
	
	
	contains



end module smod


submodule (smod) smod_s


	contains
	
		module function func_smod(x,y) result(z)
			real(dp), intent(in) :: x,y
			real(dp) :: z
			z = x+y
		end function func_smod
		
		
		module procedure func_smod2
			z = x+y
		end procedure func_smod2

end submodule smod_s

program kinds_check
    implicit none

    integer :: i,k


    do i=1,100
        k = selected_int_kind(i)
        if(k>0) write(*,*) 'Int ',i,k
    end do

    do i=1,100
        k = selected_real_kind(i)
        if(k>0) write(*,*) 'Real ',i,k
    end do


    write(*,*) 'Char ASCII',selected_char_kind('ASCII')
    write(*,*) 'Char DEFAULT',selected_char_kind('DEFAULT')
    write(*,*) 'Char ISO_10646',selected_char_kind('ISO_10646')



end program kinds_check

! Int            1           1
! Int            2           1
! Int            3           2
! Int            4           2
! Int            5           4
! Int            6           4
! Int            7           4
! Int            8           4
! Int            9           4
! Int           10           8
! Int           11           8
! Int           12           8
! Int           13           8
! Int           14           8
! Int           15           8
! Int           16           8
! Int           17           8
! Int           18           8
! Int           19          16
! Int           20          16
! Int           21          16
! Int           22          16
! Int           23          16
! Int           24          16
! Int           25          16
! Int           26          16
! Int           27          16
! Int           28          16
! Int           29          16
! Int           30          16
! Int           31          16
! Int           32          16
! Int           33          16
! Int           34          16
! Int           35          16
! Int           36          16
! Int           37          16
! Int           38          16
! Real            1           4
! Real            2           4
! Real            3           4
! Real            4           4
! Real            5           4
! Real            6           4
! Real            7           8
! Real            8           8
! Real            9           8
! Real           10           8
! Real           11           8
! Real           12           8
! Real           13           8
! Real           14           8
! Real           15           8
! Real           16          10
! Real           17          10
! Real           18          10
! Real           19          16
! Real           20          16
! Real           21          16
! Real           22          16
! Real           23          16
! Real           24          16
! Real           25          16
! Real           26          16
! Real           27          16
! Real           28          16
! Real           29          16
! Real           30          16
! Real           31          16
! Real           32          16
! Real           33          16
! Char ASCII           1
! Char DEFAULT           1
! Char ISO_10646           4

! SPDX-License-Identifier: GPL-2.0+

module comp
	use iso_fortran_env, only: output_unit, real128


	implicit none
	
		! Parameters
		integer, parameter :: dp = selected_real_kind(p=15)
		integer, parameter :: qp = selected_real_kind(p=30)
		integer, parameter :: lp = selected_int_kind(8)
		
		
		complex, parameter         :: const_cmplx=(1.0,1.0)
		complex(dp), parameter  :: const_cmplx_dp=(1.0_dp,1.0_dp)
		complex(qp), parameter  :: const_cmplx_qp=(1.0_qp,1.0_qp)
		
		
		complex             :: a_cmplx
		complex(dp)       :: a_cmplx_dp
		complex(qp)       :: a_cmplx_qp
		
		
		complex              :: a_cmplx_set
		complex(dp)       :: a_cmplx_dp_set
		complex(qp)       :: a_cmplx_qp_set
	
	contains

	subroutine sub_cmplx_inout(c)
		complex, intent(inout) :: c
	
		c =c *5
	
	end subroutine sub_cmplx_inout

	complex function func_ret_cmplx(c)
		complex, intent(inout) :: c
	
		func_ret_cmplx = c*5
		
	end function func_ret_cmplx

	subroutine sub_cmplx_value(c,cc)
		complex, intent(in), value :: c
		complex, intent(out) :: cc
	
		cc = c *5
	
	end subroutine sub_cmplx_value


end module comp

! SPDX-License-Identifier: GPL-2.0+

module com

	use iso_fortran_env, only: output_unit, real128
	
	implicit none
	
	! Parameters
	integer, parameter :: dp = selected_real_kind(p=15)
	integer, parameter :: qp = selected_real_kind(p=30)
	integer, parameter :: lp = selected_int_kind(8)
	
	
	integer :: x_int, y_int, z_int
	common  x_int, y_int, z_int
	
	integer :: x_int1, y_int1, z_int1
	common  /com_mod/ x_int1, y_int1, z_int1
	
	integer :: x_int2, y_int2
	common  /com_mod2/ x_int2, y_int2
	
	
	contains

!https://stackoverflow.com/questions/39533409/access-common-block-variables-from-ctypes

	subroutine sub_setup_common()
	
		integer ::  a_int,b_int,c_int
		common  /comm1/ a_int,b_int,c_int
	
	
	end subroutine sub_setup_common


end module com

module params2
    implicit none

    integer, parameter :: dp = selected_real_kind(p=15)  ! real64


   real(dp), parameter :: pi = 3.1415926535897932384626433832795028841971693993751d0
   real(dp), parameter :: pi2 = pi*pi
   real(dp), parameter :: pi4 = 4*pi
   real(dp), parameter :: eulercon = 0.577215664901532861d0
   real(dp), parameter :: eulernum = 2.71828182845904523536028747135266249d0
   real(dp), parameter :: ln2 = 6.9314718055994529D-01  ! = log(2d0)
   real(dp), parameter :: ln3 = 1.0986122886681096D+00  ! = log(3d0)
   real(dp), parameter :: lnPi = 1.14472988584940017414343_dp  ! = log(pi)
   real(dp), parameter :: ln10 = 2.3025850929940455_dp  ! = log(10d0)
   real(dp), parameter :: iln10 = 0.43429448190325187_dp  ! = 1d0/log(10d0)
   real(dp), parameter :: a2rad = pi/180.0d0  ! angle to radians
   real(dp), parameter :: rad2a = 180.0d0/pi  ! radians to angle
   real(dp), parameter :: one_third = 1d0/3d0
   real(dp), parameter :: two_thirds = 2d0/3d0
   real(dp), parameter :: four_thirds = 4d0/3d0
   real(dp), parameter :: five_thirds = 5d0/3d0
   real(dp), parameter :: one_sixth = 1d0/6d0
   real(dp), parameter :: four_thirds_pi = four_thirds*pi
   real(dp), parameter :: ln4pi3 = 1.4324119583011810d0  ! = log(4*pi/3)
   real(dp), parameter :: two_13 = 1.2599210498948730d0  ! = pow(2d0,1d0/3d0)
   real(dp), parameter :: four_13 = 1.5874010519681994d0  ! = pow(4d0,1d0/3d0)
   real(dp), parameter :: sqrt2 = 1.414213562373095d0  ! = sqrt(2)
   real(dp), parameter :: sqrt_2_div_3 = 0.816496580927726d0  ! = sqrt(2/3)


   ! CODATA 2018
   real(dp), parameter :: avo = 6.02214076d23  ! Avogadro constant (mole^-1)
   real(dp), parameter :: amu = 1d0/avo  ! atomic mass unit (g)
   real(dp), parameter :: clight = 2.99792458d10  ! speed of light in vacuum (cm s^-1)
   real(dp), parameter :: qe = (clight/10d0)*1.602176634d-19  ! elementary charge (esu == (g cm^3 s^-2)^(1/2))
   real(dp), parameter :: kerg = 1.380649d-16
   real(dp), parameter :: boltzm = kerg  ! Boltzmann constant (erg K^-1)
   real(dp), parameter :: planck_h = 6.62607015d-27  ! Planck constant (erg s)
   real(dp), parameter :: hbar = planck_h/(2*pi)
   real(dp), parameter :: cgas = boltzm*avo  ! ideal gas constant (erg K^-1)
   real(dp), parameter :: ev2erg = 1.602176634d-12  ! electron volt (erg)
   real(dp), parameter :: mev_to_ergs = 1d6*ev2erg
   real(dp), parameter :: mev_amu = mev_to_ergs/amu
   real(dp), parameter :: mev2gr = 1d6*ev2erg/(clight*clight)  ! MeV to grams
   real(dp), parameter :: Qconv = mev_to_ergs*avo
   real(dp), parameter :: kev = kerg/ev2erg  ! converts temp to ev (ev K^-1)
   real(dp), parameter :: boltz_sigma = (pi*pi*boltzm*boltzm*boltzm*boltzm)/(60*hbar*hbar*hbar*clight*clight)  ! Stefan-Boltzmann constant (erg cm^-2 K^-4 s^-1)
   real(dp), parameter :: crad = boltz_sigma*4/clight  ! radiation density constant, AKA "a" (erg cm^-3 K^-4); Prad = crad * T^4 / 3

   ! IAU
   real(dp), parameter :: au = 1.49597870700D13  ! (cm) - exact value defined by IAU 2009, 2012
   real(dp), parameter :: pc = (3.600D3*rad2a)*au  ! (cm) parsec, by definition
   real(dp), parameter :: dayyer = 365.25d0  ! days per (Julian) year
   real(dp), parameter :: secday = 24*60*60  ! seconds in a day
   real(dp), parameter :: secyer = secday*dayyer  ! seconds per year
   real(dp), parameter :: ly = clight*secyer  ! light year (cm)

   real(dp), parameter :: mn = 1.67492749804d-24  ! neutron mass (g)
   real(dp), parameter :: mp = 1.67262192369d-24  ! proton mass (g)
   real(dp), parameter :: me = 9.1093837015d-28  ! electron mass (g)

   real(dp), parameter :: rbohr = 5.29177210903d-9  ! Bohr radius (cm)
   real(dp), parameter :: fine = 7.2973525693d-3   ! fine-structure constant
   real(dp), parameter :: hion = 13.605693122994d0  ! Rydberg constant (eV)

   real(dp), parameter :: sige = 6.6524587321d-25  ! Thomson cross section (cm^2)

   real(dp), parameter :: weinberg_theta = 0.22290d0  ! sin**2(theta_weinberg)
   real(dp), parameter :: num_neu_fam = 3.0d0  ! number of neutrino flavors = 3.02 plus/minus 0.005 (1998)



   real(dp), parameter :: mpi = -3.1415926535897932384626433832795028841971693993751d0
   real(dp), parameter :: mpi2 = -pi*pi
   real(dp), parameter :: mpi4 = -4*pi
   real(dp), parameter :: meulercon = -0.577215664901532861d0
   real(dp), parameter :: meulernum = -2.71828182845904523536028747135266249d0
   real(dp), parameter :: mln2 = -6.9314718055994529D-01  ! = log(2d0)
   real(dp), parameter :: mln3 = -1.0986122886681096D+00  ! = log(3d0)
   real(dp), parameter :: mlnPi = -1.14472988584940017414343_dp  ! = log(pi)
   real(dp), parameter :: mln10 = -2.3025850929940455_dp  ! = log(10d0)
   real(dp), parameter :: miln10 = -0.43429448190325187_dp  ! = 1d0/log(10d0)
   real(dp), parameter :: ma2rad = -pi/180.0d0  ! angle to radians
   real(dp), parameter :: mrad2a = -180.0d0/pi  ! radians to angle
   real(dp), parameter :: mone_third = -1d0/3d0
   real(dp), parameter :: mtwo_thirds = -2d0/3d0
   real(dp), parameter :: mfour_thirds = -4d0/3d0
   real(dp), parameter :: mfive_thirds = -5d0/3d0
   real(dp), parameter :: mone_sixth = -1d0/6d0
   real(dp), parameter :: mfour_thirds_pi = -four_thirds*pi
   real(dp), parameter :: mln4pi3 = -1.4324119583011810d0  ! = log(4*pi/3)
   real(dp), parameter :: mtwo_13 = -1.2599210498948730d0  ! = pow(2d0,1d0/3d0)
   real(dp), parameter :: mfour_13 = -1.5874010519681994d0  ! = pow(4d0,1d0/3d0)
   real(dp), parameter :: msqrt2 = -1.414213562373095d0  ! = sqrt(2)
   real(dp), parameter :: msqrt_2_div_3 = -0.816496580927726d0  ! = sqrt(2/3)


   ! CODATA 2018
   real(dp), parameter :: mavo = -6.02214076d23  ! Avogadro constant (mole^-1)
   real(dp), parameter :: mamu = -1d0/avo  ! atomic mass unit (g)
   real(dp), parameter :: mclight = -2.99792458d10  ! speed of light in vacuum (cm s^-1)
   real(dp), parameter :: mqe = -(clight/10d0)*1.602176634d-19  ! elementary charge (esu == (g cm^3 s^-2)^(1/2))
   real(dp), parameter :: mkerg = -1.380649d-16
   real(dp), parameter :: mboltzm = -kerg  ! Boltzmann constant (erg K^-1)
   real(dp), parameter :: mplanck_h = -6.62607015d-27  ! Planck constant (erg s)
   real(dp), parameter :: mhbar = -planck_h/(2*pi)
   real(dp), parameter :: mcgas = -boltzm*avo  ! ideal gas constant (erg K^-1)
   real(dp), parameter :: mev2erg = -1.602176634d-12  ! electron volt (erg)
   real(dp), parameter :: mmev_to_ergs = -1d6*ev2erg
   real(dp), parameter :: mmev_amu = -mev_to_ergs/amu
   real(dp), parameter :: mmev2gr = -1d6*ev2erg/(clight*clight)  ! MeV to grams
   real(dp), parameter :: mQconv = -mev_to_ergs*avo
   real(dp), parameter :: mkev = -kerg/ev2erg  ! converts temp to ev (ev K^-1)
   real(dp), parameter :: mboltz_sigma = -(pi*pi*boltzm*boltzm*boltzm*boltzm)/(60*hbar*hbar*hbar*clight*clight)  ! Stefan-Boltzmann constant (erg cm^-2 K^-4 s^-1)
   real(dp), parameter :: mcrad = -boltz_sigma*4/clight  ! radiation density constant, AKA "a" (erg cm^-3 K^-4); Prad = crad * T^4 / 3

   ! IAU
   real(dp), parameter :: mau = -1.49597870700D13  ! (cm) - exact value defined by IAU 2009, 2012
   real(dp), parameter :: mpc = -(3.600D3*rad2a)*au  ! (cm) parsec, by definition
   real(dp), parameter :: mdayyer = -365.25d0  ! days per (Julian) year
   real(dp), parameter :: msecday = -24*60*60  ! seconds in a day
   real(dp), parameter :: msecyer = -secday*dayyer  ! seconds per year
   real(dp), parameter :: mly = -clight*secyer  ! light year (cm)

   real(dp), parameter :: mmn = -1.67492749804d-24  ! neutron mass (g)
   real(dp), parameter :: mmp = -1.67262192369d-24  ! proton mass (g)
   real(dp), parameter :: mme = -9.1093837015d-28  ! electron mass (g)

   real(dp), parameter :: mrbohr = -5.29177210903d-9  ! Bohr radius (cm)
   real(dp), parameter :: mfine = -7.2973525693d-3   ! fine-structure constant
   real(dp), parameter :: mhion = -13.605693122994d0  ! Rydberg constant (eV)

   real(dp), parameter :: msige = -6.6524587321d-25  ! Thomson cross section (cm^2)

   real(dp), parameter :: mweinberg_theta = -0.22290d0  ! sin**2(theta_weinberg)
   real(dp), parameter :: mnum_neu_fam = -3.0d0  ! number of neutrino flavors = 3.02 plus/minus 0.005 (1998)


end module params2

! SPDX-License-Identifier: GPL-2.0+

module isoc

	use iso_fortran_env, only: output_unit, real128
	use iso_c_binding
	
	implicit none
	
	! Parameters
	integer, parameter :: dp = selected_real_kind(p=15)
	integer, parameter :: qp = selected_real_kind(p=30)
	integer, parameter :: lp = selected_int_kind(16)
	

	integer, bind(C,name='a_int_bind_c') :: a_int = 1
	
	contains


	integer function func_bind_c(x) bind(C,name='c_bind_func')
		integer, intent(in) :: x
		func_bind_c = 2*x

	end function func_bind_c


end module isoc

   

! SPDX-License-Identifier: GPL-2.0+

module gh56

	use iso_fortran_env, only: output_unit, real128
	
	implicit none
	
	! Parameters
	integer, parameter :: dp = selected_real_kind(p=15)
	integer, parameter :: qp = selected_real_kind(p=30)
	integer, parameter :: lp = selected_int_kind(16)
	
	
	public :: get_array, print3, my_t

	type my_t
		real, allocatable :: d(:)
		integer :: n
	end type
	
	contains 
	
	function get_array(N) result(retval)
		type(my_t) :: retval
		integer, intent(in) :: N
		integer :: i
		
		allocate( retval%d(N) )
		retval%n = N
		
		! substitute with real data 
		do i=1,N
			retval% d(i) = i
		end do
	end function
	
	subroutine print3(x)
		type(my_t), intent(in) :: x
		print *, x%d(:3)
	end subroutine



end module gh56

        

#!/bin/bash

if [[ -z "$1" ]]; then
	echo "Set version tag"
	exit 1
fi

BRANCH=$(git rev-parse --abbrev-ref HEAD)
if [[ "$BRANCH" != "main" ]]; then
  echo 'Not on master branch'
  exit 1
fi


VERSION=$1

if [[ $VERSION == v* ]];then
	export VERSION=${VERSION#"v"}
fi

sed -i "s/__version__\ =.*/__version__\ =\ '$VERSION'/" gfort2py/version.py
sed -i "s/Current\ stable\ version\ is\ .*/Current\ stable\ version\ is\ $VERSION/" README.md


git commit gfort2py/version.py README.md -m "New release"
git tag v$VERSION
git push
git push origin v$VERSION
python setup.py sdist

echo "Now do: twine upload dist/gfort2py-$VERSION.tar.gz"

#!/bin/bash

export NAME="s390x"
export TOOLCHAIN_NAME="s390x-linux-gnu"
export DOCKER_CONTAINER="s390x/ubuntu:22.04"
export PLATFORM_NAME="linux/s390x"

cd ~/src/gfort2py/tests
make clean
cd ~/src/gfort2py

docker run --rm --privileged multiarch/qemu-user-static --reset -p yes
docker load -i docker_${TOOLCHAIN_NAME}.tar

docker start ${TOOLCHAIN_NAME}

docker run -v $(pwd):/gfort2py  --ulimit core=0  --platform ${PLATFORM_NAME} ${TOOLCHAIN_NAME}  /bin/bash -c "cd /gfort2py && python -m pip install . && python -m pytest -v"

#!/bin/bash

export NAME="ppc64le"
export TOOLCHAIN_NAME="powerpc64le-linux-gnu"
export DOCKER_CONTAINER="ppc64le/ubuntu:22.04"
export PLATFORM_NAME="linux/ppc64le"


cd ~/src/gfort2py/tests
make clean
cd ~/src/gfort2py

docker run --rm --privileged multiarch/qemu-user-static --reset -p yes
docker load -i docker_${TOOLCHAIN_NAME}.tar

docker start ${TOOLCHAIN_NAME}

docker run -v $(pwd):/gfort2py --platform ${PLATFORM_NAME} ${TOOLCHAIN_NAME} /bin/bash -c "cd /gfort2py && python -m pip install . && python -m pytest -v"

---
name: Bug report
about: Create a report to help us improve
title: "[BUG]"
labels: bug
assignees: ''

---

**Describe the bug**
A clear and concise description of what the bug is.

**Fortran code**
Minimal Fortran needed to reproduce this bug

**Python code**
Minimal Python needed to reproduce this bug

**Software (please complete the following information):**
 - OS: [e.g. Linux]
 - gfort2py version:
 - gfortran version:
 - gfortran compile options:
 - Python version:
 - If this involves arrays numpy version:

**Additional context**
Add any other context about the problem here.

---
name: Feature request
about: Suggest an idea for this project
title: "[ENH]"
labels: enhancement
assignees: ''

---

**Description of the new feature**

**Proposed Fortran code**
An example of what the Fortran code looks like

**Proposed Python code**
An example of what the Python code might look like

# Supported platforms

Here we describe the support available for different platforms, where platform means the combination of the CPU architecture, OS, and Python interpreter. Support for new platforms is welcome, but will be limited by what can be run on a Github action or other free CI testing system.


## Level 1 Support

These platforms are fully supported and all features should work. We test for all combinations of supported Python (>=3.7) and gfortran (>=8) versions when available on the platform.

- x86_64/Linux/CPython
- x86_64/MacOS/CPython
- arm/MacOS/CPython (M-Chips) (Only gfortan >=9)
- x64/Windows/CPython (via Choco)


## Level 2 Support

These platforms are fully supported and all features should work. However we only test a single supported Python and gfortran version.

- x86_64/Linux/PyPy
- x64/Windows/CPython (via Cygwin)
- arm32v7/Linux/CPython
- riscv64/Linux/CPython

## Level 3 Support

These platforms are partially supported and not all features work. We only test a single supported Python and gfortran version. To find unsupported features search the test suite for the given error message.

- s390x/Linux/CPython ('Skip on big endian systems')
- ppc64le/Linux/CPython ('Skip on ppc64le systems')

# Unsupported platforms

No platforms are currently unsupported.

# Planned platforms

These platforms may work but we have not yet gotten the test suite running on these platforms. Support is planned for the future.

No additional platforms are currently planned.

For those wanting to dig further into ``gfort2py``.

Assuming that you loaded things as:

````python
x = gf.fFort(SO, MOD)
````

You can find out the available Fortran variables/procedures module information with:

````python
var = x._module['variable_name']
````

## Variables

For variables you can create a ``fVar`` (the object that handles converting too and from Python to Fortran) with:

````python
fvar = gf.fVar.fVar(var,x._module)
````

Note that at this point the ``fvar`` has no idea where to look for the variable. If you want to access its value in a module then

````python
fvar.in_dll(x._lib)
print(fvar.value)
````

and you can then set the value (after calling ``in_dll``) with:

````python
fvar.value = value
````

## Procedures

For a procedure you can do:

````python
proc = x._module['procedure_name']
````

and its Fortran object is:

````python
fproc = gf.fProc.fProc(x._lib,proc,x._module)
````

Calling the procedure is then:

````python
fproc(*args,**kwargs)
````

To access the arguments of a procedure then:

````python
args = [x._module[i.ref] for i in proc.args().symbol]
````

The return value of a function is accessed via:

````python
return_arg = x._module[proc.return_arg()]
````

## Derived types

To access a derived type (the type definition not an instance of the type)

````python
dt_type = x._module['Derived_name']
````

Note the capitalization, derived types start with a capital.

Similar to a variable, to access an instance of a derived type variable its:

````python
dt_var = x._module['dt_variable_name']
dt_fvar = gf.fVar.fVar(dt_var,x._module)
````
